# - *- coding: utf- 8 - *-
# 2022.11.29 cp from dsk_fastapi.py | docker run -d --restart=always --name gecdsk -p 7000:7000 -v /data/cikuu/pypi/dsk/gec-dsk.py:/gec-dsk.py wrask/spacy:3.4.1 python gec-dsk.py uvirun 7000 
import json, requests,time,sys, traceback, difflib,os, re, spacy, redis
if not hasattr(spacy, 'nlp'): 
	from spacy.lang import en
	spacy.sntbr		= (inst := en.English(), inst.add_pipe("sentencizer"))[0]
	spacy.sntpid	= lambda essay: (pid:=0, [ ( pid := pid + 1 if "\n" in snt.text else pid,  (snt.text, pid))[-1] for snt in  spacy.sntbr(essay).sents] )[-1]
	spacy.nlp = spacy.load(os.getenv('spacy_model', 'en_core_web_sm') ) 

has_cl			= lambda d: any([t for t in d if t.dep_ in ('xcomp','ccomp','mark','csubj','relcl','pcomp')])
cl_num			= lambda ess: len([d for d in ess['docs'] if has_cl(d)])
snt_spell_err	= lambda mkf: len( {v.get('kp','') for k,v in mkf['feedback'].items() if v.get('cate','') =='e_spell' })
sum_spell_err	= lambda mkfs: sum([snt_spell_err(mkf) for mkf in mkfs])
has_grammar_err	= lambda mkf: any([k for k,v in mkf['feedback'].items() if v.get('cate','').startswith("e_")])
snt_kp_err		= lambda mkf: len({k for k,v in mkf['feedback'].items() if v.get('cate','').startswith("e_")})
kperr_perc		= lambda mkf: snt_kp_err(mkf) / (mkf.get('meta',{}).get('tc',0.01) + 0.01) # added 2022.11.29
kperr_perc_ri	= lambda mkf: abs(1 - kperr_perc(mkf))  # added 2022.11.29
sum_kp_err		= lambda mkfs: sum([snt_kp_err(mkf) for mkf in mkfs ] ) 
kp_correct_ratio= lambda mkfs, tc: 1.0 - sum_kp_err(mkfs)/tc

def sntbr(essay, trim:bool=False, with_pid:bool=False): 
	''' sntbr("[\u8bd1\u6587]The 55-kilometre Hong Kong Zhuhai-Macau Bridge is an extraordinary engineering. It is the world's longest sea-crossing transportation system combining bridges and tunnels, which joins the three cities of Hong Kong Zhuhai and Macao, cutting the travelling time among them from 3 hours to 30 minutes. The reinforced concrete bridge with huge spans fully not only proves that China has the ability to complete the record-breaking mega-construction, but also will enhance the regional integration and boost the economic growth. It plays a crucial role in the overall plan to develop China’s Great Bay Area, which China intends to turn into one rivaling those of San Francisco, New York and Tokyo in terms of technological innovation and economic prosperity.") '''
	from spacy.lang import en
	if not hasattr(sntbr, 'inst'): 
		sntbr.inst = en.English()
		sntbr.inst.add_pipe("sentencizer")

	doc = sntbr.inst(essay)
	if not with_pid: return [ snt.text.strip() if trim else snt.text for snt in  doc.sents]
	pid = 0 #spacy.sntpidoff	= lambda essay: (pid:=0, doc:=spacy.sntbr(essay), [ ( pid := pid + 1 if "\n" in snt.text else pid,  (snt.text, pid, doc[snt.start].idx))[-1] for snt in  doc.sents] )[-1]
	arr = []
	for snt in  doc.sents:
		if "\n" in snt.text: pid = pid + 1 
		arr.append( (snt.text, pid) ) 
	return arr 

def rconn(name:str="gpu120.wrask.com:6379"):  
	if name is None or not name : return None 
	if not hasattr(rconn, name): setattr(rconn, name , redis.Redis(host=name.split(':')[0], port=int(name.split(':')[-1]), decode_responses=True) )
	return getattr(rconn, name) 

def getdocs(snts, redis_r):
	if redis_r is None : return [spacy.nlp(snt) for snt in snts] 
	reslist = redis_r.mget([f"snt:{snt}" for snt in snts]) # prefill by spacy 3.4.1
	return  [ spacy.nlp(snt) if res is None else  spacy.tokens.Doc(spacy.nlp.vocab).from_json(json.loads(res) ) for snt, res in zip(snts, reslist) ]

trans_diff		= lambda src, trg:  [] if src == trg else [s for s in difflib.ndiff(src, trg) if not s.startswith('?')] #src:list, trg:list
trans_diff_merge= lambda src, trg:  [] if src == trg else [s.strip() for s in "^".join([s for s in difflib.ndiff(src, trg) if not s.startswith('?')]).replace("^+","|+").split("^") if not s.startswith("+") ]
def mkf_input(snts, docs, tokenizer, sntdic:dict={},diffmerge:bool=False): # mkf input for 7095 java calling 
	srcs	= [ [t.text for t in doc] for doc in docs]
	tgts	= [ [t.text for t in doc] if ( snt not in sntdic or snt == sntdic.get(snt,snt) ) else [t.text for t in tokenizer(sntdic.get(snt,snt))] for snt, doc in zip(snts, docs)]
	input	= [ {"pid":0, "sid":i, "snt":snts[i], "tok": [t.text for t in doc],  
				"pos":[t.tag_ for t in doc], "dep": [t.dep_ for t in doc],"head":[t.head.i for t in doc],  
				"seg":[ ("NP", sp.start, sp.end) for sp in doc.noun_chunks] + [ (np.label_, np.start,np.end) for np in doc.ents] , 
				"gec": sntdic.get(snts[i],snts[i]), "diff": trans_diff_merge( srcs[i] , tgts[i]) if diffmerge else  trans_diff( srcs[i] , tgts[i] )	}
				for i, doc in enumerate(docs)]
	return input 

def xgecsnts(redis_gec, snts:list=["She has ready.","It are ok."], timeout:int=9,): #gechost:str='gpu120.wrask.com', gecport:int=6379
	''' {'She has ready.': 'She is ready.', 'It are ok.': 'It is ok.'}  2022.11.21 '''
	if redis_gec is None: return {}
	id	= redis_gec.xadd("xsnts", {'snts':json.dumps(snts)})
	res = redis_gec.blpop([f"suc:{id}",f"err:{id}"], timeout=timeout)
	redis_gec.xdel("xsnts", id)
	return {} if res is None else json.loads(res[1])

def gec_local(snts:list=["She has ready.","It are ok."],  redis_cache=None):
	import gecv1
	return gecv1.gecsnts(snts, mget=lambda snts: [None for snt in snts] if redis_cache is None else redis_cache.mget)

def gecdsk(essay_or_snts:str="She has ready. It are ok. I think it is right.",timeout:int=9, redis_cache=None, redis_gec=None,  #  redis_cache=None, redis_gec=None,# when None, means gec_local:bool=False, | redis_r=None,
		 ttl:int=47200, use_gec:bool=True, topk_gec:int=64, dskhost:str='gpu120.wrask.com:7095'):  
	''' assure: rgec_host is in the white ip list, added 2022.7.19 '''
	tims	= [time.time()]
	sntpids = spacy.sntpid(essay_or_snts) if not essay_or_snts.startswith('["') else [] # [(snt,pid) ]
	snts	= json.loads(essay_or_snts) if essay_or_snts.startswith('["') else [snt for snt,pid in sntpids ] #sntbr(essay_or_snts)
	if redis_cache is not None: [redis_cache.xadd('xsnt', {'snt':snt}, maxlen=30000) for snt in snts] # to notify xsnt-spacy, xsnt-gec 

	sntdic = {} if not use_gec else xgecsnts(redis_gec, snts[0:topk_gec],timeout=timeout) if redis_gec else gec_local(snts[0:topk_gec], redis_cache)
	if redis_cache is not None: [redis_cache.setex(f"gec:{snt}", ttl, gec) for snt, gec in sntdic.items()]
	tims.append(time.time())
	
	docs	= getdocs(snts, redis_cache) #[parse(snt) for snt in snts ] 
	tims.append(time.time())
	input	= mkf_input(snts, docs, spacy.nlp.tokenizer, sntdic)
	dsk		= requests.post(f"http://{dskhost}/parser", data={"q":json.dumps({"snts":input, "rid":"10"} ).encode("utf-8")}).json()
	tims.append(time.time())

	if len(sntpids) == len(dsk['snt']): # added 2022.11.29
		for i, mkf in enumerate(dsk['snt']): 
			mkf.get('meta',{}).update({"pid": sntpids[i][1]}) # para_id

	dims = dsk.get('doc',{})
	mkfs = dsk.get('snt',[])#ess['pred_verbs']	= { t.lemma_ for d in docs for t in d if t.dep_ == 'ROOT' and t.tag_.startswith('V') and t.lemma_ in word_idf}
	if dims:  
		dims.update({"tc":len([t for d in docs for t in d if len(t.text.strip()) > 0]) + 0.01, 	"sntnum": len(docs)})
		dims['cl_sum']	= len([d for d in docs if has_cl(d)]) # cp from sntsdims.py 
		dims['cl_dens']	= dims['cl_sum'] / dims['snt_num']
		dims['pv_dens']	= dims.get("mwe_pv",0) / dims['snt_num']

		dims['spell_correct_ratio'] = 1.0 - sum_spell_err(mkfs)/dims['tc'] # need by pingyu
		dims['snt_correct_ratio']	= kp_correct_ratio(mkfs, dims['tc']) #dims['cola'] # need by pingyu
		dims['grammar_correct_ri']	= sum([ abs(1.0 - kperr_perc(mkf)) for mkf in mkfs])/dims['snt_num'] #dims['grammar_correct_ri']	= 1.0 - len([mkf for mkf in mkfs if has_grammar_err(mkf) ])/dims['snt_num']
		dims['kp_correct_ri']		= 1.0 / ( 1.0 + kp_correct_ratio(mkfs, dims['tc']))
	
	dsk['tim'] = {'gec': tims[1] - tims[0] , 'parse': tims[2] - tims[1] , 'mkf': tims[3] - tims[2] } # for debug only 
	dsk['gec'] = sntdic # for debug only, added 2022.11.22
	return dsk

import bisect
pingyu_default = { 
'ast': [[0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 1.9, 2.0, 2.1, 2.2, 2.3, 2.4, 2.5, 2.6, 2.7, 2.8, 2.9, 3.0, 3.1, 3.2, 3.3, 3.4, 3.5, 3.6, 3.79, 3.8, 3.81, 3.82, 3.83, 3.84, 3.85, 3.86, 3.87, 3.88, 3.89, 3.9, 3.91, 3.92, 3.93, 3.94, 3.942, 3.945, 3.95, 3.955, 3.96, 3.965, 3.97, 3.975, 3.98, 3.985, 3.99, 3.995, 4.0, 4.015, 4.03, 4.045, 4.06, 4.075, 4.09, 4.105, 4.12, 4.135, 4.15, 4.165, 4.18, 4.195, 4.21, 4.225, 4.24, 4.255, 4.27, 4.285, 4.29, 4.305, 4.325, 4.35, 4.355, 4.36, 4.365, 4.37, 4.375, 4.38, 4.385, 4.39, 4.395, 4.4, 4.405, 4.41, 4.415, 4.42, 4.425, 4.43, 4.435, 4.44, 4.445, 4.45, 4.455, 4.46, 4.465, 4.47, 4.475, 4.48, 4.485, 4.49, 4.495, 4.5, 4.5, 4.505, 4.51, 4.515, 4.52, 4.52, 4.525, 4.53, 4.535, 4.54, 4.545, 4.547, 4.55, 4.56, 4.59, 4.62, 4.65, 4.68, 4.71, 4.74, 4.77, 4.8, 4.83, 4.86, 4.89, 4.92, 4.95, 4.98, 5.01, 5.04, 5.07, 5.13, 5.16, 5.19, 5.22, 5.25, 5.28, 5.31, 5.37, 5.43, 5.47, 5.5, 5.53, 5.54, 5.55, 5.56, 5.57, 5.58, 5.59, 5.61, 5.62, 5.63, 5.64, 5.65, 5.66, 5.67, 5.68, 5.69, 5.7, 5.71, 5.72, 5.73, 5.74, 5.75, 5.76, 5.77, 5.78, 5.79, 5.8, 5.81, 5.82, 5.83, 5.84, 5.85, 5.86, 5.87, 5.88, 5.89, 5.9, 5.91, 5.92, 5.925, 5.93, 5.94, 5.945, 5.95, 5.96, 5.97, 5.98, 5.99, 5.995, 6.0, 6.05, 6.1, 6.15, 6.2, 6.25, 6.3, 6.35, 6.4, 6.45, 6.47, 6.5, 6.53, 6.56, 6.59, 6.62, 6.65, 6.68, 6.71, 6.74, 6.77, 6.8, 6.83, 6.86, 6.92, 6.95, 6.98, 7.13, 7.2, 7.25, 7.3, 7.35, 7.4, 7.45, 7.5, 7.55, 7.6, 7.65, 7.7], ['词汇表达贫乏', '用词太过单一', '用词稍显贫乏', '文章用词太过单一', '请作者增加词汇量的积累', '文章词汇表达不够丰富', '文中用词稍显贫乏', '请作者增加词汇丰富度', '请注意积累词汇量', '请注意词汇表达的多样性', '请增加词汇量的积累', '请作者注意积累词汇量', '请作者增加词汇表达的丰富度', '文中词汇表达稍欠丰富', '文中词汇表达贫乏', '请注意词汇量的积累', '作者词汇量偏小', '作者词汇量偏少', '请注意增加词汇的积累', '作者词汇基础较薄弱', '文中词汇表达不够丰富', '文中词汇表达过于贫乏', '请作者增加词汇表达的丰富度，注意积累词汇量', '增加词汇表达丰富度', '作者词汇量不足', '文中词汇表达太过贫乏', '请注意积累词汇量，文中词汇表达贫乏', '总体用词稍显贫乏', '词汇表达总体不够丰富', '词汇量偏少', '请作者增加词汇表达', '词汇表达不够灵活', '词汇量总体上不足', '请增加词汇的积累', '整体词汇不够丰富', '总体词汇量偏小', '需增加词汇量', '作者词汇表达不够丰富', '作者词汇量偏小，文章用词太过单一', '请注意词汇量的增加', '请注意积累词汇', '文中词汇表达不灵活', '注意积累词汇量', '文章用词过于单一', '请使用丰富多样的词汇表达', '文中词汇表达多样性不足', '请使用灵活多样的词汇表达', '文中词汇稍显贫乏', '作者词汇量提升空间很大', '总体词汇表达不够丰富', '总体表达较呆板', '词汇不够丰富', '总体用词较为单一', '需增加词汇丰富度', '要注意积累词汇量', '总体词汇量较小', '词汇总体比较贫乏', '词汇量积累不足', '需注意增加词汇丰富度', '需注意积累词汇量', '表达不灵活', '总体词汇表达不够灵活', '用词稍显单一', '文中词汇表达总体贫乏', '需请作者增加词汇丰富度', '作者词汇量有些小', '再增加词汇量积累就更好了', '作者词汇量较小', '文章用词有些单一', '请作者增加词汇表达的灵活性', '文章词汇表达稍显呆板', '作者词汇表达不够灵活', '文中词汇表达稍显单一', '词汇表达不够丰富', '总体词汇表达贫乏', '需增加词汇表达灵活性', '词汇量积累需要继续加大努力', '请作者注意增加词汇表达的丰富度', '词汇量总体较小', '词汇表达稍显贫乏', '若能增加词汇丰富度就更好了', '日常练习中要注意积累词汇量', '希望能改善用词单一的情况', '词汇量总体偏小', '词汇量的积累还要努力', '文中词汇表达稍显贫乏', '需作者增加词汇丰富度', '总体词汇量稍小', '文中词汇表达多样性要加强', '文中词汇表达丰富度要加强', '作者词汇表达丰富度不足', '文章词汇不够丰富', '文中词汇丰富度不足', '希望作者能加强词汇表达多样性', '请作者注意词汇表达多样性', '作者词汇积累很好', '文章词汇表达多样性要提高', '文中缺乏丰富的词汇表达', '文章词汇表达多样性不够', '作者词汇表达不够多样', '文章词汇表达丰富度要提高', '文中词汇表达丰富度要提升', '作者词汇表达的灵活性要加强', '文中词汇多样性稍有欠缺', '作者词汇表达灵活性稍有欠缺', '作者使用词汇表达不够灵活', '作者词汇表达丰富度要继续提升', '请作者提高词汇表达丰富度', '词汇表达丰富度不足', '文中词汇表达丰富度不足', '文章词汇表达要更加熟练', '平时练习过程中应注意词汇量的积累', '词汇稍欠丰富', '文章词汇使用多样性不足', '文中词汇丰富度还有很大的提升空间', '请作者在词汇丰富度提升上多下功夫', '文中词汇表达灵活性要提高', '词汇积累还有很大进步空间', '请作者加强词汇表达的多样性', '文章词汇丰富度要继续努力', '作者词汇多样性不足', '文中词汇丰富度要提高', '作者能较灵活地使用词汇表达', '文中词汇多样性不足', '词汇量还要继续积累', '词汇丰富度总体不足', '文章词汇使用要更加灵活', '作者词汇表达较恰当', '词汇多样性还不够', '文章词汇使用要多样些', '文中词汇表达较准确', '作者用词较为灵活', '文章词汇多样性要提升', '请加强词汇表达的多样性', '文中词汇表达较熟练丰富度不够', '作者能较熟练地使用丰富的词汇', '词汇表达较灵活准确', '文章词汇表达比较灵活', '文中词汇表达较灵活', '作者能较灵活的使用词汇', '文章词汇表达多样性尚可', '文中词汇表达较为丰富准确', '作者能较准确地使用丰富的词汇', '文章词汇表达比较丰富', '文中词汇表达较丰富恰当', '作者词汇表达较为熟练', '词汇表达丰富度要注意', '请作者加强词汇表达的灵活性', '作者词汇表达较准确熟练', '文章用了较为丰富的词汇', '文中词汇表达较灵活丰富', '文中词汇较灵活', '作者能较熟练、灵活地使用词汇', '文中词汇表达比较多样', '作者词汇使用较为丰富熟练', '作者能较灵活地使用词汇', '作者词汇表达比较多样', '作者词汇表达较丰富准确', '作者平时练习中应扩充词汇量', '作者能较灵活准确地使用词汇表达', '在平时练习中注意词汇量的积累', '作者词汇量比较丰富', '文中词汇表达比较丰富', '文章词汇使用丰富度还要提高', '作者能较熟练地使用词汇表达', '词汇量尚可', '作者能较多样地使用词汇', '文中词汇表达用的较灵活', '词汇量积累还要努力', '作者能较灵活准确地使用词汇', '词汇表达较为丰富', '总体词汇丰富度要加强', '高级词汇表达灵活', '词汇表达较丰富', '作者词汇表达较灵活', '作者能较熟练的使用不同词汇', '文章词汇表达较丰富', '文中词汇表达较为丰富', '文中词汇使用较丰富', '作者词汇量积累很好', '文章丰富的词汇表达请发扬', '文中词汇表达较为多样', '作者能较多样的使用词汇表达', '文章能较灵活使用词汇', '作者词汇表达丰富度较高', '作者用词表达较丰富', '请作者词汇表达更加灵活多变一些', '作者能较熟练地使用多样的词汇表达', '词汇表达用的较丰富', '文中词汇表达较为灵活', '作者词汇表达较丰富', '文章词汇使用比较恰当', '文中词汇表达使用较丰富', '作者能较熟练地使用较丰富词汇', '文中词汇表达方面较丰富灵活', '文章词汇使用较为恰当灵活', '作者词汇基础挺好', '文章词汇丰富度较好', '文中能使用多样的词汇表达', '作者词汇量积累较好', '作者词汇量积累需要继续努力', '作者能较恰当使用丰富词汇', '文章词汇表达灵活恰当', '文中词汇使用较丰富恰当', '文章使用了较丰富的词汇表达', '作者词汇表达较丰富多样', '平时练习中注意词汇量的积累', '词汇量需积累', '作者词汇表达比较灵活多变', '作者词汇表达较多样灵活', '文章词汇表达丰富', '文中词汇使用灵活', '文中词汇表达灵活多样', '作者词汇基础不错', '作者用词生动多样', '用词丰富', '作者词汇表达恰当灵活', '作者词汇基础扎实', '作者词汇表达恰当', '作者词汇表达灵活多样请继续发扬', '词汇运用灵活', '作者词汇量积累不错', '文中用词灵活多样', '作者词汇积累不错', '文章用词灵活多样', '高级词汇量还要多多积累', '作者词汇基本功很好', '词汇表达灵活多样请继续保持', '文中词汇表达多样请继续保持', '词汇表达灵活多样', '作者用词灵活多样', '用词灵活多样', '词汇表达灵活丰富请继续保持', '文章词汇表达多样请继续保持', '作者词汇表达灵活多样请继续保持', '文中词汇表达灵活多样请继续保持', '文中词汇表达灵活多变', '作者词汇基本功不错', '作者词汇表达灵活丰富', '作者词汇基础很好', '作者词汇使用熟练灵活', '作者词汇表达丰富灵活', '作者词汇基本功很棒', '文中词汇的表达很灵活', '词汇表达丰富、灵活', '词汇基本功不错', '作者词汇表达丰富多彩', '文章词汇表达做的很好']],
'b3':[[0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 1.9, 2.0, 2.1, 2.2, 2.3, 2.4, 2.5, 2.6, 2.7, 2.8, 2.9, 3.0, 3.1, 3.2, 3.3, 3.4, 3.5, 3.6, 3.79, 3.8, 3.81, 3.82, 3.83, 3.84, 3.85, 3.86, 3.87, 3.88, 3.89, 3.9, 3.91, 3.92, 3.93, 3.94, 3.942, 3.945, 3.95, 3.955, 3.96, 3.965, 3.97, 3.975, 3.98, 3.985, 3.99, 3.995, 4.0, 4.015, 4.03, 4.045, 4.06, 4.075, 4.09, 4.105, 4.12, 4.135, 4.15, 4.165, 4.18, 4.195, 4.21, 4.225, 4.24, 4.255, 4.27, 4.285, 4.29, 4.305, 4.325, 4.35, 4.355, 4.36, 4.365, 4.37, 4.375, 4.38, 4.385, 4.39, 4.395, 4.4, 4.405, 4.41, 4.415, 4.42, 4.425, 4.43, 4.435, 4.44, 4.445, 4.45, 4.455, 4.46, 4.465, 4.47, 4.475, 4.48, 4.485, 4.49, 4.495, 4.5, 4.5, 4.505, 4.51, 4.515, 4.52, 4.52, 4.525, 4.53, 4.535, 4.54, 4.545, 4.547, 4.55, 4.56, 4.59, 4.62, 4.65, 4.68, 4.71, 4.74, 4.77, 4.8, 4.83, 4.86, 4.89, 4.92, 4.95, 4.98, 5.01, 5.04, 5.07, 5.13, 5.16, 5.19, 5.22, 5.25, 5.28, 5.31, 5.37, 5.43, 5.47, 5.5, 5.53, 5.54, 5.55, 5.56, 5.57, 5.58, 5.59, 5.61, 5.62, 5.63, 5.64, 5.65, 5.66, 5.67, 5.68, 5.69, 5.7, 5.71, 5.72, 5.73, 5.74, 5.75, 5.76, 5.77, 5.78, 5.79, 5.8, 5.81, 5.82, 5.83, 5.84, 5.85, 5.86, 5.87, 5.88, 5.89, 5.9, 5.91, 5.92, 5.925, 5.93, 5.94, 5.945, 5.95, 5.96, 5.97, 5.98, 5.99, 5.995, 6.0, 6.05, 6.1, 6.15, 6.2, 6.25, 6.3, 6.35, 6.4, 6.45, 6.47, 6.5, 6.53, 6.56, 6.59, 6.62, 6.65, 6.68, 6.71, 6.74, 6.77, 6.8, 6.83, 6.86, 6.92, 6.95, 6.98, 7.13, 7.2, 7.25, 7.3, 7.35, 7.4, 7.45, 7.5, 7.55, 7.6, 7.65, 7.7], ['词汇表达贫乏', '用词太过单一', '用词稍显贫乏', '文章用词太过单一', '请作者增加词汇量的积累', '文章词汇表达不够丰富', '文中用词稍显贫乏', '请作者增加词汇丰富度', '请注意积累词汇量', '请注意词汇表达的多样性', '请增加词汇量的积累', '请作者注意积累词汇量', '请作者增加词汇表达的丰富度', '文中词汇表达稍欠丰富', '文中词汇表达贫乏', '请注意词汇量的积累', '作者词汇量偏小', '作者词汇量偏少', '请注意增加词汇的积累', '作者词汇基础较薄弱', '文中词汇表达不够丰富', '文中词汇表达过于贫乏', '请作者增加词汇表达的丰富度，注意积累词汇量', '增加词汇表达丰富度', '作者词汇量不足', '文中词汇表达太过贫乏', '请注意积累词汇量，文中词汇表达贫乏', '总体用词稍显贫乏', '词汇表达总体不够丰富', '词汇量偏少', '请作者增加词汇表达', '词汇表达不够灵活', '词汇量总体上不足', '请增加词汇的积累', '整体词汇不够丰富', '总体词汇量偏小', '需增加词汇量', '作者词汇表达不够丰富', '作者词汇量偏小，文章用词太过单一', '请注意词汇量的增加', '请注意积累词汇', '文中词汇表达不灵活', '注意积累词汇量', '文章用词过于单一', '请使用丰富多样的词汇表达', '文中词汇表达多样性不足', '请使用灵活多样的词汇表达', '文中词汇稍显贫乏', '作者词汇量提升空间很大', '总体词汇表达不够丰富', '总体表达较呆板', '词汇不够丰富', '总体用词较为单一', '需增加词汇丰富度', '要注意积累词汇量', '总体词汇量较小', '词汇总体比较贫乏', '词汇量积累不足', '需注意增加词汇丰富度', '需注意积累词汇量', '表达不灵活', '总体词汇表达不够灵活', '用词稍显单一', '文中词汇表达总体贫乏', '需请作者增加词汇丰富度', '作者词汇量有些小', '再增加词汇量积累就更好了', '作者词汇量较小', '文章用词有些单一', '请作者增加词汇表达的灵活性', '文章词汇表达稍显呆板', '作者词汇表达不够灵活', '文中词汇表达稍显单一', '词汇表达不够丰富', '总体词汇表达贫乏', '需增加词汇表达灵活性', '词汇量积累需要继续加大努力', '请作者注意增加词汇表达的丰富度', '词汇量总体较小', '词汇表达稍显贫乏', '若能增加词汇丰富度就更好了', '日常练习中要注意积累词汇量', '希望能改善用词单一的情况', '词汇量总体偏小', '词汇量的积累还要努力', '文中词汇表达稍显贫乏', '需作者增加词汇丰富度', '总体词汇量稍小', '文中词汇表达多样性要加强', '文中词汇表达丰富度要加强', '作者词汇表达丰富度不足', '文章词汇不够丰富', '文中词汇丰富度不足', '希望作者能加强词汇表达多样性', '请作者注意词汇表达多样性', '作者词汇积累很好', '文章词汇表达多样性要提高', '文中缺乏丰富的词汇表达', '文章词汇表达多样性不够', '作者词汇表达不够多样', '文章词汇表达丰富度要提高', '文中词汇表达丰富度要提升', '作者词汇表达的灵活性要加强', '文中词汇多样性稍有欠缺', '作者词汇表达灵活性稍有欠缺', '作者使用词汇表达不够灵活', '作者词汇表达丰富度要继续提升', '请作者提高词汇表达丰富度', '词汇表达丰富度不足', '文中词汇表达丰富度不足', '文章词汇表达要更加熟练', '平时练习过程中应注意词汇量的积累', '词汇稍欠丰富', '文章词汇使用多样性不足', '文中词汇丰富度还有很大的提升空间', '请作者在词汇丰富度提升上多下功夫', '文中词汇表达灵活性要提高', '词汇积累还有很大进步空间', '请作者加强词汇表达的多样性', '文章词汇丰富度要继续努力', '作者词汇多样性不足', '文中词汇丰富度要提高', '作者能较灵活地使用词汇表达', '文中词汇多样性不足', '词汇量还要继续积累', '词汇丰富度总体不足', '文章词汇使用要更加灵活', '作者词汇表达较恰当', '词汇多样性还不够', '文章词汇使用要多样些', '文中词汇表达较准确', '作者用词较为灵活', '文章词汇多样性要提升', '请加强词汇表达的多样性', '文中词汇表达较熟练丰富度不够', '作者能较熟练地使用丰富的词汇', '词汇表达较灵活准确', '文章词汇表达比较灵活', '文中词汇表达较灵活', '作者能较灵活的使用词汇', '文章词汇表达多样性尚可', '文中词汇表达较为丰富准确', '作者能较准确地使用丰富的词汇', '文章词汇表达比较丰富', '文中词汇表达较丰富恰当', '作者词汇表达较为熟练', '词汇表达丰富度要注意', '请作者加强词汇表达的灵活性', '作者词汇表达较准确熟练', '文章用了较为丰富的词汇', '文中词汇表达较灵活丰富', '文中词汇较灵活', '作者能较熟练、灵活地使用词汇', '文中词汇表达比较多样', '作者词汇使用较为丰富熟练', '作者能较灵活地使用词汇', '作者词汇表达比较多样', '作者词汇表达较丰富准确', '作者平时练习中应扩充词汇量', '作者能较灵活准确地使用词汇表达', '在平时练习中注意词汇量的积累', '作者词汇量比较丰富', '文中词汇表达比较丰富', '文章词汇使用丰富度还要提高', '作者能较熟练地使用词汇表达', '词汇量尚可', '作者能较多样地使用词汇', '文中词汇表达用的较灵活', '词汇量积累还要努力', '作者能较灵活准确地使用词汇', '词汇表达较为丰富', '总体词汇丰富度要加强', '高级词汇表达灵活', '词汇表达较丰富', '作者词汇表达较灵活', '作者能较熟练的使用不同词汇', '文章词汇表达较丰富', '文中词汇表达较为丰富', '文中词汇使用较丰富', '作者词汇量积累很好', '文章丰富的词汇表达请发扬', '文中词汇表达较为多样', '作者能较多样的使用词汇表达', '文章能较灵活使用词汇', '作者词汇表达丰富度较高', '作者用词表达较丰富', '请作者词汇表达更加灵活多变一些', '作者能较熟练地使用多样的词汇表达', '词汇表达用的较丰富', '文中词汇表达较为灵活', '作者词汇表达较丰富', '文章词汇使用比较恰当', '文中词汇表达使用较丰富', '作者能较熟练地使用较丰富词汇', '文中词汇表达方面较丰富灵活', '文章词汇使用较为恰当灵活', '作者词汇基础挺好', '文章词汇丰富度较好', '文中能使用多样的词汇表达', '作者词汇量积累较好', '作者词汇量积累需要继续努力', '作者能较恰当使用丰富词汇', '文章词汇表达灵活恰当', '文中词汇使用较丰富恰当', '文章使用了较丰富的词汇表达', '作者词汇表达较丰富多样', '平时练习中注意词汇量的积累', '词汇量需积累', '作者词汇表达比较灵活多变', '作者词汇表达较多样灵活', '文章词汇表达丰富', '文中词汇使用灵活', '文中词汇表达灵活多样', '作者词汇基础不错', '作者用词生动多样', '用词丰富', '作者词汇表达恰当灵活', '作者词汇基础扎实', '作者词汇表达恰当', '作者词汇表达灵活多样请继续发扬', '词汇运用灵活', '作者词汇量积累不错', '文中用词灵活多样', '作者词汇积累不错', '文章用词灵活多样', '高级词汇量还要多多积累', '作者词汇基本功很好', '词汇表达灵活多样请继续保持', '文中词汇表达多样请继续保持', '词汇表达灵活多样', '作者用词灵活多样', '用词灵活多样', '词汇表达灵活丰富请继续保持', '文章词汇表达多样请继续保持', '作者词汇表达灵活多样请继续保持', '文中词汇表达灵活多样请继续保持', '文中词汇表达灵活多变', '作者词汇基本功不错', '作者词汇表达灵活丰富', '作者词汇基础很好', '作者词汇使用熟练灵活', '作者词汇表达丰富灵活', '作者词汇基本功很棒', '文中词汇的表达很灵活', '词汇表达丰富、灵活', '词汇基本功不错', '作者词汇表达丰富多彩', '文章词汇表达做的很好']],
'cl_dens':[[0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 1.9, 2.0, 2.1, 2.2, 2.3, 2.4, 2.5, 2.6, 2.7, 2.8, 2.9, 3.0, 3.1, 3.2, 3.3, 3.4, 3.5, 3.6, 3.79, 3.8, 3.81, 3.82, 3.83, 3.84, 3.85, 3.86, 3.87, 3.88, 3.89, 3.9, 3.91, 3.92, 3.93, 3.94, 3.942, 3.945, 3.95, 3.955, 3.96, 3.965, 3.97, 3.975, 3.98, 3.985, 3.99, 3.995, 4.0, 4.015, 4.03, 4.045, 4.06, 4.075, 4.09, 4.105, 4.12, 4.135, 4.15, 4.165, 4.18, 4.195, 4.21, 4.225, 4.24, 4.255, 4.27, 4.285, 4.29, 4.305, 4.325, 4.35, 4.355, 4.36, 4.365, 4.37, 4.375, 4.38, 4.385, 4.39, 4.395, 4.4, 4.405, 4.41, 4.415, 4.42, 4.425, 4.43, 4.435, 4.44, 4.445, 4.45, 4.455, 4.46, 4.465, 4.47, 4.475, 4.48, 4.485, 4.49, 4.495, 4.5, 4.5, 4.505, 4.51, 4.515, 4.52, 4.52, 4.525, 4.53, 4.535, 4.54, 4.545, 4.547, 4.55, 4.56, 4.59, 4.62, 4.65, 4.68, 4.71, 4.74, 4.77, 4.8, 4.83, 4.86, 4.89, 4.92, 4.95, 4.98, 5.01, 5.04, 5.07, 5.13, 5.16, 5.19, 5.22, 5.25, 5.28, 5.31, 5.37, 5.43, 5.47, 5.5, 5.53, 5.54, 5.55, 5.56, 5.57, 5.58, 5.59, 5.61, 5.62, 5.63, 5.64, 5.65, 5.66, 5.67, 5.68, 5.69, 5.7, 5.71, 5.72, 5.73, 5.74, 5.75, 5.76, 5.77, 5.78, 5.79, 5.8, 5.81, 5.82, 5.83, 5.84, 5.85, 5.86, 5.87, 5.88, 5.89, 5.9, 5.91, 5.92, 5.925, 5.93, 5.94, 5.945, 5.95, 5.96, 5.97, 5.98, 5.99, 5.995, 6.0, 6.05, 6.1, 6.15, 6.2, 6.25, 6.3, 6.35, 6.4, 6.45, 6.47, 6.5, 6.53, 6.56, 6.59, 6.62, 6.65, 6.68, 6.71, 6.74, 6.77, 6.8, 6.83, 6.86, 6.92, 6.95, 6.98, 7.13, 7.2, 7.25, 7.3, 7.35, 7.4, 7.45, 7.5, 7.55, 7.6, 7.65, 7.7], ['词汇表达贫乏', '用词太过单一', '用词稍显贫乏', '文章用词太过单一', '请作者增加词汇量的积累', '文章词汇表达不够丰富', '文中用词稍显贫乏', '请作者增加词汇丰富度', '请注意积累词汇量', '请注意词汇表达的多样性', '请增加词汇量的积累', '请作者注意积累词汇量', '请作者增加词汇表达的丰富度', '文中词汇表达稍欠丰富', '文中词汇表达贫乏', '请注意词汇量的积累', '作者词汇量偏小', '作者词汇量偏少', '请注意增加词汇的积累', '作者词汇基础较薄弱', '文中词汇表达不够丰富', '文中词汇表达过于贫乏', '请作者增加词汇表达的丰富度，注意积累词汇量', '增加词汇表达丰富度', '作者词汇量不足', '文中词汇表达太过贫乏', '请注意积累词汇量，文中词汇表达贫乏', '总体用词稍显贫乏', '词汇表达总体不够丰富', '词汇量偏少', '请作者增加词汇表达', '词汇表达不够灵活', '词汇量总体上不足', '请增加词汇的积累', '整体词汇不够丰富', '总体词汇量偏小', '需增加词汇量', '作者词汇表达不够丰富', '作者词汇量偏小，文章用词太过单一', '请注意词汇量的增加', '请注意积累词汇', '文中词汇表达不灵活', '注意积累词汇量', '文章用词过于单一', '请使用丰富多样的词汇表达', '文中词汇表达多样性不足', '请使用灵活多样的词汇表达', '文中词汇稍显贫乏', '作者词汇量提升空间很大', '总体词汇表达不够丰富', '总体表达较呆板', '词汇不够丰富', '总体用词较为单一', '需增加词汇丰富度', '要注意积累词汇量', '总体词汇量较小', '词汇总体比较贫乏', '词汇量积累不足', '需注意增加词汇丰富度', '需注意积累词汇量', '表达不灵活', '总体词汇表达不够灵活', '用词稍显单一', '文中词汇表达总体贫乏', '需请作者增加词汇丰富度', '作者词汇量有些小', '再增加词汇量积累就更好了', '作者词汇量较小', '文章用词有些单一', '请作者增加词汇表达的灵活性', '文章词汇表达稍显呆板', '作者词汇表达不够灵活', '文中词汇表达稍显单一', '词汇表达不够丰富', '总体词汇表达贫乏', '需增加词汇表达灵活性', '词汇量积累需要继续加大努力', '请作者注意增加词汇表达的丰富度', '词汇量总体较小', '词汇表达稍显贫乏', '若能增加词汇丰富度就更好了', '日常练习中要注意积累词汇量', '希望能改善用词单一的情况', '词汇量总体偏小', '词汇量的积累还要努力', '文中词汇表达稍显贫乏', '需作者增加词汇丰富度', '总体词汇量稍小', '文中词汇表达多样性要加强', '文中词汇表达丰富度要加强', '作者词汇表达丰富度不足', '文章词汇不够丰富', '文中词汇丰富度不足', '希望作者能加强词汇表达多样性', '请作者注意词汇表达多样性', '作者词汇积累很好', '文章词汇表达多样性要提高', '文中缺乏丰富的词汇表达', '文章词汇表达多样性不够', '作者词汇表达不够多样', '文章词汇表达丰富度要提高', '文中词汇表达丰富度要提升', '作者词汇表达的灵活性要加强', '文中词汇多样性稍有欠缺', '作者词汇表达灵活性稍有欠缺', '作者使用词汇表达不够灵活', '作者词汇表达丰富度要继续提升', '请作者提高词汇表达丰富度', '词汇表达丰富度不足', '文中词汇表达丰富度不足', '文章词汇表达要更加熟练', '平时练习过程中应注意词汇量的积累', '词汇稍欠丰富', '文章词汇使用多样性不足', '文中词汇丰富度还有很大的提升空间', '请作者在词汇丰富度提升上多下功夫', '文中词汇表达灵活性要提高', '词汇积累还有很大进步空间', '请作者加强词汇表达的多样性', '文章词汇丰富度要继续努力', '作者词汇多样性不足', '文中词汇丰富度要提高', '作者能较灵活地使用词汇表达', '文中词汇多样性不足', '词汇量还要继续积累', '词汇丰富度总体不足', '文章词汇使用要更加灵活', '作者词汇表达较恰当', '词汇多样性还不够', '文章词汇使用要多样些', '文中词汇表达较准确', '作者用词较为灵活', '文章词汇多样性要提升', '请加强词汇表达的多样性', '文中词汇表达较熟练丰富度不够', '作者能较熟练地使用丰富的词汇', '词汇表达较灵活准确', '文章词汇表达比较灵活', '文中词汇表达较灵活', '作者能较灵活的使用词汇', '文章词汇表达多样性尚可', '文中词汇表达较为丰富准确', '作者能较准确地使用丰富的词汇', '文章词汇表达比较丰富', '文中词汇表达较丰富恰当', '作者词汇表达较为熟练', '词汇表达丰富度要注意', '请作者加强词汇表达的灵活性', '作者词汇表达较准确熟练', '文章用了较为丰富的词汇', '文中词汇表达较灵活丰富', '文中词汇较灵活', '作者能较熟练、灵活地使用词汇', '文中词汇表达比较多样', '作者词汇使用较为丰富熟练', '作者能较灵活地使用词汇', '作者词汇表达比较多样', '作者词汇表达较丰富准确', '作者平时练习中应扩充词汇量', '作者能较灵活准确地使用词汇表达', '在平时练习中注意词汇量的积累', '作者词汇量比较丰富', '文中词汇表达比较丰富', '文章词汇使用丰富度还要提高', '作者能较熟练地使用词汇表达', '词汇量尚可', '作者能较多样地使用词汇', '文中词汇表达用的较灵活', '词汇量积累还要努力', '作者能较灵活准确地使用词汇', '词汇表达较为丰富', '总体词汇丰富度要加强', '高级词汇表达灵活', '词汇表达较丰富', '作者词汇表达较灵活', '作者能较熟练的使用不同词汇', '文章词汇表达较丰富', '文中词汇表达较为丰富', '文中词汇使用较丰富', '作者词汇量积累很好', '文章丰富的词汇表达请发扬', '文中词汇表达较为多样', '作者能较多样的使用词汇表达', '文章能较灵活使用词汇', '作者词汇表达丰富度较高', '作者用词表达较丰富', '请作者词汇表达更加灵活多变一些', '作者能较熟练地使用多样的词汇表达', '词汇表达用的较丰富', '文中词汇表达较为灵活', '作者词汇表达较丰富', '文章词汇使用比较恰当', '文中词汇表达使用较丰富', '作者能较熟练地使用较丰富词汇', '文中词汇表达方面较丰富灵活', '文章词汇使用较为恰当灵活', '作者词汇基础挺好', '文章词汇丰富度较好', '文中能使用多样的词汇表达', '作者词汇量积累较好', '作者词汇量积累需要继续努力', '作者能较恰当使用丰富词汇', '文章词汇表达灵活恰当', '文中词汇使用较丰富恰当', '文章使用了较丰富的词汇表达', '作者词汇表达较丰富多样', '平时练习中注意词汇量的积累', '词汇量需积累', '作者词汇表达比较灵活多变', '作者词汇表达较多样灵活', '文章词汇表达丰富', '文中词汇使用灵活', '文中词汇表达灵活多样', '作者词汇基础不错', '作者用词生动多样', '用词丰富', '作者词汇表达恰当灵活', '作者词汇基础扎实', '作者词汇表达恰当', '作者词汇表达灵活多样请继续发扬', '词汇运用灵活', '作者词汇量积累不错', '文中用词灵活多样', '作者词汇积累不错', '文章用词灵活多样', '高级词汇量还要多多积累', '作者词汇基本功很好', '词汇表达灵活多样请继续保持', '文中词汇表达多样请继续保持', '词汇表达灵活多样', '作者用词灵活多样', '用词灵活多样', '词汇表达灵活丰富请继续保持', '文章词汇表达多样请继续保持', '作者词汇表达灵活多样请继续保持', '文中词汇表达灵活多样请继续保持', '文中词汇表达灵活多变', '作者词汇基本功不错', '作者词汇表达灵活丰富', '作者词汇基础很好', '作者词汇使用熟练灵活', '作者词汇表达丰富灵活', '作者词汇基本功很棒', '文中词汇的表达很灵活', '词汇表达丰富、灵活', '词汇基本功不错', '作者词汇表达丰富多彩', '文章词汇表达做的很好']],
'disconj_dens':[[0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 1.9, 2.0, 2.1, 2.2, 2.3, 2.4, 2.5, 2.6, 2.7, 2.8, 2.9, 3.0, 3.1, 3.2, 3.3, 3.4, 3.5, 3.6, 3.79, 3.8, 3.81, 3.82, 3.83, 3.84, 3.85, 3.86, 3.87, 3.88, 3.89, 3.9, 3.91, 3.92, 3.93, 3.94, 3.942, 3.945, 3.95, 3.955, 3.96, 3.965, 3.97, 3.975, 3.98, 3.985, 3.99, 3.995, 4.0, 4.015, 4.03, 4.045, 4.06, 4.075, 4.09, 4.105, 4.12, 4.135, 4.15, 4.165, 4.18, 4.195, 4.21, 4.225, 4.24, 4.255, 4.27, 4.285, 4.29, 4.305, 4.325, 4.35, 4.355, 4.36, 4.365, 4.37, 4.375, 4.38, 4.385, 4.39, 4.395, 4.4, 4.405, 4.41, 4.415, 4.42, 4.425, 4.43, 4.435, 4.44, 4.445, 4.45, 4.455, 4.46, 4.465, 4.47, 4.475, 4.48, 4.485, 4.49, 4.495, 4.5, 4.5, 4.505, 4.51, 4.515, 4.52, 4.52, 4.525, 4.53, 4.535, 4.54, 4.545, 4.547, 4.55, 4.56, 4.59, 4.62, 4.65, 4.68, 4.71, 4.74, 4.77, 4.8, 4.83, 4.86, 4.89, 4.92, 4.95, 4.98, 5.01, 5.04, 5.07, 5.13, 5.16, 5.19, 5.22, 5.25, 5.28, 5.31, 5.37, 5.43, 5.47, 5.5, 5.53, 5.54, 5.55, 5.56, 5.57, 5.58, 5.59, 5.61, 5.62, 5.63, 5.64, 5.65, 5.66, 5.67, 5.68, 5.69, 5.7, 5.71, 5.72, 5.73, 5.74, 5.75, 5.76, 5.77, 5.78, 5.79, 5.8, 5.81, 5.82, 5.83, 5.84, 5.85, 5.86, 5.87, 5.88, 5.89, 5.9, 5.91, 5.92, 5.925, 5.93, 5.94, 5.945, 5.95, 5.96, 5.97, 5.98, 5.99, 5.995, 6.0, 6.05, 6.1, 6.15, 6.2, 6.25, 6.3, 6.35, 6.4, 6.45, 6.47, 6.5, 6.53, 6.56, 6.59, 6.62, 6.65, 6.68, 6.71, 6.74, 6.77, 6.8, 6.83, 6.86, 6.92, 6.95, 6.98, 7.13, 7.2, 7.25, 7.3, 7.35, 7.4, 7.45, 7.5, 7.55, 7.6, 7.65, 7.7], ['词汇表达贫乏', '用词太过单一', '用词稍显贫乏', '文章用词太过单一', '请作者增加词汇量的积累', '文章词汇表达不够丰富', '文中用词稍显贫乏', '请作者增加词汇丰富度', '请注意积累词汇量', '请注意词汇表达的多样性', '请增加词汇量的积累', '请作者注意积累词汇量', '请作者增加词汇表达的丰富度', '文中词汇表达稍欠丰富', '文中词汇表达贫乏', '请注意词汇量的积累', '作者词汇量偏小', '作者词汇量偏少', '请注意增加词汇的积累', '作者词汇基础较薄弱', '文中词汇表达不够丰富', '文中词汇表达过于贫乏', '请作者增加词汇表达的丰富度，注意积累词汇量', '增加词汇表达丰富度', '作者词汇量不足', '文中词汇表达太过贫乏', '请注意积累词汇量，文中词汇表达贫乏', '总体用词稍显贫乏', '词汇表达总体不够丰富', '词汇量偏少', '请作者增加词汇表达', '词汇表达不够灵活', '词汇量总体上不足', '请增加词汇的积累', '整体词汇不够丰富', '总体词汇量偏小', '需增加词汇量', '作者词汇表达不够丰富', '作者词汇量偏小，文章用词太过单一', '请注意词汇量的增加', '请注意积累词汇', '文中词汇表达不灵活', '注意积累词汇量', '文章用词过于单一', '请使用丰富多样的词汇表达', '文中词汇表达多样性不足', '请使用灵活多样的词汇表达', '文中词汇稍显贫乏', '作者词汇量提升空间很大', '总体词汇表达不够丰富', '总体表达较呆板', '词汇不够丰富', '总体用词较为单一', '需增加词汇丰富度', '要注意积累词汇量', '总体词汇量较小', '词汇总体比较贫乏', '词汇量积累不足', '需注意增加词汇丰富度', '需注意积累词汇量', '表达不灵活', '总体词汇表达不够灵活', '用词稍显单一', '文中词汇表达总体贫乏', '需请作者增加词汇丰富度', '作者词汇量有些小', '再增加词汇量积累就更好了', '作者词汇量较小', '文章用词有些单一', '请作者增加词汇表达的灵活性', '文章词汇表达稍显呆板', '作者词汇表达不够灵活', '文中词汇表达稍显单一', '词汇表达不够丰富', '总体词汇表达贫乏', '需增加词汇表达灵活性', '词汇量积累需要继续加大努力', '请作者注意增加词汇表达的丰富度', '词汇量总体较小', '词汇表达稍显贫乏', '若能增加词汇丰富度就更好了', '日常练习中要注意积累词汇量', '希望能改善用词单一的情况', '词汇量总体偏小', '词汇量的积累还要努力', '文中词汇表达稍显贫乏', '需作者增加词汇丰富度', '总体词汇量稍小', '文中词汇表达多样性要加强', '文中词汇表达丰富度要加强', '作者词汇表达丰富度不足', '文章词汇不够丰富', '文中词汇丰富度不足', '希望作者能加强词汇表达多样性', '请作者注意词汇表达多样性', '作者词汇积累很好', '文章词汇表达多样性要提高', '文中缺乏丰富的词汇表达', '文章词汇表达多样性不够', '作者词汇表达不够多样', '文章词汇表达丰富度要提高', '文中词汇表达丰富度要提升', '作者词汇表达的灵活性要加强', '文中词汇多样性稍有欠缺', '作者词汇表达灵活性稍有欠缺', '作者使用词汇表达不够灵活', '作者词汇表达丰富度要继续提升', '请作者提高词汇表达丰富度', '词汇表达丰富度不足', '文中词汇表达丰富度不足', '文章词汇表达要更加熟练', '平时练习过程中应注意词汇量的积累', '词汇稍欠丰富', '文章词汇使用多样性不足', '文中词汇丰富度还有很大的提升空间', '请作者在词汇丰富度提升上多下功夫', '文中词汇表达灵活性要提高', '词汇积累还有很大进步空间', '请作者加强词汇表达的多样性', '文章词汇丰富度要继续努力', '作者词汇多样性不足', '文中词汇丰富度要提高', '作者能较灵活地使用词汇表达', '文中词汇多样性不足', '词汇量还要继续积累', '词汇丰富度总体不足', '文章词汇使用要更加灵活', '作者词汇表达较恰当', '词汇多样性还不够', '文章词汇使用要多样些', '文中词汇表达较准确', '作者用词较为灵活', '文章词汇多样性要提升', '请加强词汇表达的多样性', '文中词汇表达较熟练丰富度不够', '作者能较熟练地使用丰富的词汇', '词汇表达较灵活准确', '文章词汇表达比较灵活', '文中词汇表达较灵活', '作者能较灵活的使用词汇', '文章词汇表达多样性尚可', '文中词汇表达较为丰富准确', '作者能较准确地使用丰富的词汇', '文章词汇表达比较丰富', '文中词汇表达较丰富恰当', '作者词汇表达较为熟练', '词汇表达丰富度要注意', '请作者加强词汇表达的灵活性', '作者词汇表达较准确熟练', '文章用了较为丰富的词汇', '文中词汇表达较灵活丰富', '文中词汇较灵活', '作者能较熟练、灵活地使用词汇', '文中词汇表达比较多样', '作者词汇使用较为丰富熟练', '作者能较灵活地使用词汇', '作者词汇表达比较多样', '作者词汇表达较丰富准确', '作者平时练习中应扩充词汇量', '作者能较灵活准确地使用词汇表达', '在平时练习中注意词汇量的积累', '作者词汇量比较丰富', '文中词汇表达比较丰富', '文章词汇使用丰富度还要提高', '作者能较熟练地使用词汇表达', '词汇量尚可', '作者能较多样地使用词汇', '文中词汇表达用的较灵活', '词汇量积累还要努力', '作者能较灵活准确地使用词汇', '词汇表达较为丰富', '总体词汇丰富度要加强', '高级词汇表达灵活', '词汇表达较丰富', '作者词汇表达较灵活', '作者能较熟练的使用不同词汇', '文章词汇表达较丰富', '文中词汇表达较为丰富', '文中词汇使用较丰富', '作者词汇量积累很好', '文章丰富的词汇表达请发扬', '文中词汇表达较为多样', '作者能较多样的使用词汇表达', '文章能较灵活使用词汇', '作者词汇表达丰富度较高', '作者用词表达较丰富', '请作者词汇表达更加灵活多变一些', '作者能较熟练地使用多样的词汇表达', '词汇表达用的较丰富', '文中词汇表达较为灵活', '作者词汇表达较丰富', '文章词汇使用比较恰当', '文中词汇表达使用较丰富', '作者能较熟练地使用较丰富词汇', '文中词汇表达方面较丰富灵活', '文章词汇使用较为恰当灵活', '作者词汇基础挺好', '文章词汇丰富度较好', '文中能使用多样的词汇表达', '作者词汇量积累较好', '作者词汇量积累需要继续努力', '作者能较恰当使用丰富词汇', '文章词汇表达灵活恰当', '文中词汇使用较丰富恰当', '文章使用了较丰富的词汇表达', '作者词汇表达较丰富多样', '平时练习中注意词汇量的积累', '词汇量需积累', '作者词汇表达比较灵活多变', '作者词汇表达较多样灵活', '文章词汇表达丰富', '文中词汇使用灵活', '文中词汇表达灵活多样', '作者词汇基础不错', '作者用词生动多样', '用词丰富', '作者词汇表达恰当灵活', '作者词汇基础扎实', '作者词汇表达恰当', '作者词汇表达灵活多样请继续发扬', '词汇运用灵活', '作者词汇量积累不错', '文中用词灵活多样', '作者词汇积累不错', '文章用词灵活多样', '高级词汇量还要多多积累', '作者词汇基本功很好', '词汇表达灵活多样请继续保持', '文中词汇表达多样请继续保持', '词汇表达灵活多样', '作者用词灵活多样', '用词灵活多样', '词汇表达灵活丰富请继续保持', '文章词汇表达多样请继续保持', '作者词汇表达灵活多样请继续保持', '文中词汇表达灵活多样请继续保持', '文中词汇表达灵活多变', '作者词汇基本功不错', '作者词汇表达灵活丰富', '作者词汇基础很好', '作者词汇使用熟练灵活', '作者词汇表达丰富灵活', '作者词汇基本功很棒', '文中词汇的表达很灵活', '词汇表达丰富、灵活', '词汇基本功不错', '作者词汇表达丰富多彩', '文章词汇表达做的很好']],
'pv_dens':[[0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 1.9, 2.0, 2.1, 2.2, 2.3, 2.4, 2.5, 2.6, 2.7, 2.8, 2.9, 3.0, 3.1, 3.2, 3.3, 3.4, 3.5, 3.6, 3.79, 3.8, 3.81, 3.82, 3.83, 3.84, 3.85, 3.86, 3.87, 3.88, 3.89, 3.9, 3.91, 3.92, 3.93, 3.94, 3.942, 3.945, 3.95, 3.955, 3.96, 3.965, 3.97, 3.975, 3.98, 3.985, 3.99, 3.995, 4.0, 4.015, 4.03, 4.045, 4.06, 4.075, 4.09, 4.105, 4.12, 4.135, 4.15, 4.165, 4.18, 4.195, 4.21, 4.225, 4.24, 4.255, 4.27, 4.285, 4.29, 4.305, 4.325, 4.35, 4.355, 4.36, 4.365, 4.37, 4.375, 4.38, 4.385, 4.39, 4.395, 4.4, 4.405, 4.41, 4.415, 4.42, 4.425, 4.43, 4.435, 4.44, 4.445, 4.45, 4.455, 4.46, 4.465, 4.47, 4.475, 4.48, 4.485, 4.49, 4.495, 4.5, 4.5, 4.505, 4.51, 4.515, 4.52, 4.52, 4.525, 4.53, 4.535, 4.54, 4.545, 4.547, 4.55, 4.56, 4.59, 4.62, 4.65, 4.68, 4.71, 4.74, 4.77, 4.8, 4.83, 4.86, 4.89, 4.92, 4.95, 4.98, 5.01, 5.04, 5.07, 5.13, 5.16, 5.19, 5.22, 5.25, 5.28, 5.31, 5.37, 5.43, 5.47, 5.5, 5.53, 5.54, 5.55, 5.56, 5.57, 5.58, 5.59, 5.61, 5.62, 5.63, 5.64, 5.65, 5.66, 5.67, 5.68, 5.69, 5.7, 5.71, 5.72, 5.73, 5.74, 5.75, 5.76, 5.77, 5.78, 5.79, 5.8, 5.81, 5.82, 5.83, 5.84, 5.85, 5.86, 5.87, 5.88, 5.89, 5.9, 5.91, 5.92, 5.925, 5.93, 5.94, 5.945, 5.95, 5.96, 5.97, 5.98, 5.99, 5.995, 6.0, 6.05, 6.1, 6.15, 6.2, 6.25, 6.3, 6.35, 6.4, 6.45, 6.47, 6.5, 6.53, 6.56, 6.59, 6.62, 6.65, 6.68, 6.71, 6.74, 6.77, 6.8, 6.83, 6.86, 6.92, 6.95, 6.98, 7.13, 7.2, 7.25, 7.3, 7.35, 7.4, 7.45, 7.5, 7.55, 7.6, 7.65, 7.7], ['词汇表达贫乏', '用词太过单一', '用词稍显贫乏', '文章用词太过单一', '请作者增加词汇量的积累', '文章词汇表达不够丰富', '文中用词稍显贫乏', '请作者增加词汇丰富度', '请注意积累词汇量', '请注意词汇表达的多样性', '请增加词汇量的积累', '请作者注意积累词汇量', '请作者增加词汇表达的丰富度', '文中词汇表达稍欠丰富', '文中词汇表达贫乏', '请注意词汇量的积累', '作者词汇量偏小', '作者词汇量偏少', '请注意增加词汇的积累', '作者词汇基础较薄弱', '文中词汇表达不够丰富', '文中词汇表达过于贫乏', '请作者增加词汇表达的丰富度，注意积累词汇量', '增加词汇表达丰富度', '作者词汇量不足', '文中词汇表达太过贫乏', '请注意积累词汇量，文中词汇表达贫乏', '总体用词稍显贫乏', '词汇表达总体不够丰富', '词汇量偏少', '请作者增加词汇表达', '词汇表达不够灵活', '词汇量总体上不足', '请增加词汇的积累', '整体词汇不够丰富', '总体词汇量偏小', '需增加词汇量', '作者词汇表达不够丰富', '作者词汇量偏小，文章用词太过单一', '请注意词汇量的增加', '请注意积累词汇', '文中词汇表达不灵活', '注意积累词汇量', '文章用词过于单一', '请使用丰富多样的词汇表达', '文中词汇表达多样性不足', '请使用灵活多样的词汇表达', '文中词汇稍显贫乏', '作者词汇量提升空间很大', '总体词汇表达不够丰富', '总体表达较呆板', '词汇不够丰富', '总体用词较为单一', '需增加词汇丰富度', '要注意积累词汇量', '总体词汇量较小', '词汇总体比较贫乏', '词汇量积累不足', '需注意增加词汇丰富度', '需注意积累词汇量', '表达不灵活', '总体词汇表达不够灵活', '用词稍显单一', '文中词汇表达总体贫乏', '需请作者增加词汇丰富度', '作者词汇量有些小', '再增加词汇量积累就更好了', '作者词汇量较小', '文章用词有些单一', '请作者增加词汇表达的灵活性', '文章词汇表达稍显呆板', '作者词汇表达不够灵活', '文中词汇表达稍显单一', '词汇表达不够丰富', '总体词汇表达贫乏', '需增加词汇表达灵活性', '词汇量积累需要继续加大努力', '请作者注意增加词汇表达的丰富度', '词汇量总体较小', '词汇表达稍显贫乏', '若能增加词汇丰富度就更好了', '日常练习中要注意积累词汇量', '希望能改善用词单一的情况', '词汇量总体偏小', '词汇量的积累还要努力', '文中词汇表达稍显贫乏', '需作者增加词汇丰富度', '总体词汇量稍小', '文中词汇表达多样性要加强', '文中词汇表达丰富度要加强', '作者词汇表达丰富度不足', '文章词汇不够丰富', '文中词汇丰富度不足', '希望作者能加强词汇表达多样性', '请作者注意词汇表达多样性', '作者词汇积累很好', '文章词汇表达多样性要提高', '文中缺乏丰富的词汇表达', '文章词汇表达多样性不够', '作者词汇表达不够多样', '文章词汇表达丰富度要提高', '文中词汇表达丰富度要提升', '作者词汇表达的灵活性要加强', '文中词汇多样性稍有欠缺', '作者词汇表达灵活性稍有欠缺', '作者使用词汇表达不够灵活', '作者词汇表达丰富度要继续提升', '请作者提高词汇表达丰富度', '词汇表达丰富度不足', '文中词汇表达丰富度不足', '文章词汇表达要更加熟练', '平时练习过程中应注意词汇量的积累', '词汇稍欠丰富', '文章词汇使用多样性不足', '文中词汇丰富度还有很大的提升空间', '请作者在词汇丰富度提升上多下功夫', '文中词汇表达灵活性要提高', '词汇积累还有很大进步空间', '请作者加强词汇表达的多样性', '文章词汇丰富度要继续努力', '作者词汇多样性不足', '文中词汇丰富度要提高', '作者能较灵活地使用词汇表达', '文中词汇多样性不足', '词汇量还要继续积累', '词汇丰富度总体不足', '文章词汇使用要更加灵活', '作者词汇表达较恰当', '词汇多样性还不够', '文章词汇使用要多样些', '文中词汇表达较准确', '作者用词较为灵活', '文章词汇多样性要提升', '请加强词汇表达的多样性', '文中词汇表达较熟练丰富度不够', '作者能较熟练地使用丰富的词汇', '词汇表达较灵活准确', '文章词汇表达比较灵活', '文中词汇表达较灵活', '作者能较灵活的使用词汇', '文章词汇表达多样性尚可', '文中词汇表达较为丰富准确', '作者能较准确地使用丰富的词汇', '文章词汇表达比较丰富', '文中词汇表达较丰富恰当', '作者词汇表达较为熟练', '词汇表达丰富度要注意', '请作者加强词汇表达的灵活性', '作者词汇表达较准确熟练', '文章用了较为丰富的词汇', '文中词汇表达较灵活丰富', '文中词汇较灵活', '作者能较熟练、灵活地使用词汇', '文中词汇表达比较多样', '作者词汇使用较为丰富熟练', '作者能较灵活地使用词汇', '作者词汇表达比较多样', '作者词汇表达较丰富准确', '作者平时练习中应扩充词汇量', '作者能较灵活准确地使用词汇表达', '在平时练习中注意词汇量的积累', '作者词汇量比较丰富', '文中词汇表达比较丰富', '文章词汇使用丰富度还要提高', '作者能较熟练地使用词汇表达', '词汇量尚可', '作者能较多样地使用词汇', '文中词汇表达用的较灵活', '词汇量积累还要努力', '作者能较灵活准确地使用词汇', '词汇表达较为丰富', '总体词汇丰富度要加强', '高级词汇表达灵活', '词汇表达较丰富', '作者词汇表达较灵活', '作者能较熟练的使用不同词汇', '文章词汇表达较丰富', '文中词汇表达较为丰富', '文中词汇使用较丰富', '作者词汇量积累很好', '文章丰富的词汇表达请发扬', '文中词汇表达较为多样', '作者能较多样的使用词汇表达', '文章能较灵活使用词汇', '作者词汇表达丰富度较高', '作者用词表达较丰富', '请作者词汇表达更加灵活多变一些', '作者能较熟练地使用多样的词汇表达', '词汇表达用的较丰富', '文中词汇表达较为灵活', '作者词汇表达较丰富', '文章词汇使用比较恰当', '文中词汇表达使用较丰富', '作者能较熟练地使用较丰富词汇', '文中词汇表达方面较丰富灵活', '文章词汇使用较为恰当灵活', '作者词汇基础挺好', '文章词汇丰富度较好', '文中能使用多样的词汇表达', '作者词汇量积累较好', '作者词汇量积累需要继续努力', '作者能较恰当使用丰富词汇', '文章词汇表达灵活恰当', '文中词汇使用较丰富恰当', '文章使用了较丰富的词汇表达', '作者词汇表达较丰富多样', '平时练习中注意词汇量的积累', '词汇量需积累', '作者词汇表达比较灵活多变', '作者词汇表达较多样灵活', '文章词汇表达丰富', '文中词汇使用灵活', '文中词汇表达灵活多样', '作者词汇基础不错', '作者用词生动多样', '用词丰富', '作者词汇表达恰当灵活', '作者词汇基础扎实', '作者词汇表达恰当', '作者词汇表达灵活多样请继续发扬', '词汇运用灵活', '作者词汇量积累不错', '文中用词灵活多样', '作者词汇积累不错', '文章用词灵活多样', '高级词汇量还要多多积累', '作者词汇基本功很好', '词汇表达灵活多样请继续保持', '文中词汇表达多样请继续保持', '词汇表达灵活多样', '作者用词灵活多样', '用词灵活多样', '词汇表达灵活丰富请继续保持', '文章词汇表达多样请继续保持', '作者词汇表达灵活多样请继续保持', '文中词汇表达灵活多样请继续保持', '文中词汇表达灵活多变', '作者词汇基本功不错', '作者词汇表达灵活丰富', '作者词汇基础很好', '作者词汇使用熟练灵活', '作者词汇表达丰富灵活', '作者词汇基本功很棒', '文中词汇的表达很灵活', '词汇表达丰富、灵活', '词汇基本功不错', '作者词汇表达丰富多彩', '文章词汇表达做的很好']],
'snt_correct_ratio':[[0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 1.9, 2.0, 2.1, 2.2, 2.3, 2.4, 2.5, 2.6, 2.7, 2.8, 2.9, 3.0, 3.1, 3.2, 3.3, 3.4, 3.5, 3.6, 3.79, 3.8, 3.81, 3.82, 3.83, 3.84, 3.85, 3.86, 3.87, 3.88, 3.89, 3.9, 3.91, 3.92, 3.93, 3.94, 3.942, 3.945, 3.95, 3.955, 3.96, 3.965, 3.97, 3.975, 3.98, 3.985, 3.99, 3.995, 4.0, 4.015, 4.03, 4.045, 4.06, 4.075, 4.09, 4.105, 4.12, 4.135, 4.15, 4.165, 4.18, 4.195, 4.21, 4.225, 4.24, 4.255, 4.27, 4.285, 4.29, 4.305, 4.325, 4.35, 4.355, 4.36, 4.365, 4.37, 4.375, 4.38, 4.385, 4.39, 4.395, 4.4, 4.405, 4.41, 4.415, 4.42, 4.425, 4.43, 4.435, 4.44, 4.445, 4.45, 4.455, 4.46, 4.465, 4.47, 4.475, 4.48, 4.485, 4.49, 4.495, 4.5, 4.5, 4.505, 4.51, 4.515, 4.52, 4.52, 4.525, 4.53, 4.535, 4.54, 4.545, 4.547, 4.55, 4.56, 4.59, 4.62, 4.65, 4.68, 4.71, 4.74, 4.77, 4.8, 4.83, 4.86, 4.89, 4.92, 4.95, 4.98, 5.01, 5.04, 5.07, 5.13, 5.16, 5.19, 5.22, 5.25, 5.28, 5.31, 5.37, 5.43, 5.47, 5.5, 5.53, 5.54, 5.55, 5.56, 5.57, 5.58, 5.59, 5.61, 5.62, 5.63, 5.64, 5.65, 5.66, 5.67, 5.68, 5.69, 5.7, 5.71, 5.72, 5.73, 5.74, 5.75, 5.76, 5.77, 5.78, 5.79, 5.8, 5.81, 5.82, 5.83, 5.84, 5.85, 5.86, 5.87, 5.88, 5.89, 5.9, 5.91, 5.92, 5.925, 5.93, 5.94, 5.945, 5.95, 5.96, 5.97, 5.98, 5.99, 5.995, 6.0, 6.05, 6.1, 6.15, 6.2, 6.25, 6.3, 6.35, 6.4, 6.45, 6.47, 6.5, 6.53, 6.56, 6.59, 6.62, 6.65, 6.68, 6.71, 6.74, 6.77, 6.8, 6.83, 6.86, 6.92, 6.95, 6.98, 7.13, 7.2, 7.25, 7.3, 7.35, 7.4, 7.45, 7.5, 7.55, 7.6, 7.65, 7.7], ['词汇表达贫乏', '用词太过单一', '用词稍显贫乏', '文章用词太过单一', '请作者增加词汇量的积累', '文章词汇表达不够丰富', '文中用词稍显贫乏', '请作者增加词汇丰富度', '请注意积累词汇量', '请注意词汇表达的多样性', '请增加词汇量的积累', '请作者注意积累词汇量', '请作者增加词汇表达的丰富度', '文中词汇表达稍欠丰富', '文中词汇表达贫乏', '请注意词汇量的积累', '作者词汇量偏小', '作者词汇量偏少', '请注意增加词汇的积累', '作者词汇基础较薄弱', '文中词汇表达不够丰富', '文中词汇表达过于贫乏', '请作者增加词汇表达的丰富度，注意积累词汇量', '增加词汇表达丰富度', '作者词汇量不足', '文中词汇表达太过贫乏', '请注意积累词汇量，文中词汇表达贫乏', '总体用词稍显贫乏', '词汇表达总体不够丰富', '词汇量偏少', '请作者增加词汇表达', '词汇表达不够灵活', '词汇量总体上不足', '请增加词汇的积累', '整体词汇不够丰富', '总体词汇量偏小', '需增加词汇量', '作者词汇表达不够丰富', '作者词汇量偏小，文章用词太过单一', '请注意词汇量的增加', '请注意积累词汇', '文中词汇表达不灵活', '注意积累词汇量', '文章用词过于单一', '请使用丰富多样的词汇表达', '文中词汇表达多样性不足', '请使用灵活多样的词汇表达', '文中词汇稍显贫乏', '作者词汇量提升空间很大', '总体词汇表达不够丰富', '总体表达较呆板', '词汇不够丰富', '总体用词较为单一', '需增加词汇丰富度', '要注意积累词汇量', '总体词汇量较小', '词汇总体比较贫乏', '词汇量积累不足', '需注意增加词汇丰富度', '需注意积累词汇量', '表达不灵活', '总体词汇表达不够灵活', '用词稍显单一', '文中词汇表达总体贫乏', '需请作者增加词汇丰富度', '作者词汇量有些小', '再增加词汇量积累就更好了', '作者词汇量较小', '文章用词有些单一', '请作者增加词汇表达的灵活性', '文章词汇表达稍显呆板', '作者词汇表达不够灵活', '文中词汇表达稍显单一', '词汇表达不够丰富', '总体词汇表达贫乏', '需增加词汇表达灵活性', '词汇量积累需要继续加大努力', '请作者注意增加词汇表达的丰富度', '词汇量总体较小', '词汇表达稍显贫乏', '若能增加词汇丰富度就更好了', '日常练习中要注意积累词汇量', '希望能改善用词单一的情况', '词汇量总体偏小', '词汇量的积累还要努力', '文中词汇表达稍显贫乏', '需作者增加词汇丰富度', '总体词汇量稍小', '文中词汇表达多样性要加强', '文中词汇表达丰富度要加强', '作者词汇表达丰富度不足', '文章词汇不够丰富', '文中词汇丰富度不足', '希望作者能加强词汇表达多样性', '请作者注意词汇表达多样性', '作者词汇积累很好', '文章词汇表达多样性要提高', '文中缺乏丰富的词汇表达', '文章词汇表达多样性不够', '作者词汇表达不够多样', '文章词汇表达丰富度要提高', '文中词汇表达丰富度要提升', '作者词汇表达的灵活性要加强', '文中词汇多样性稍有欠缺', '作者词汇表达灵活性稍有欠缺', '作者使用词汇表达不够灵活', '作者词汇表达丰富度要继续提升', '请作者提高词汇表达丰富度', '词汇表达丰富度不足', '文中词汇表达丰富度不足', '文章词汇表达要更加熟练', '平时练习过程中应注意词汇量的积累', '词汇稍欠丰富', '文章词汇使用多样性不足', '文中词汇丰富度还有很大的提升空间', '请作者在词汇丰富度提升上多下功夫', '文中词汇表达灵活性要提高', '词汇积累还有很大进步空间', '请作者加强词汇表达的多样性', '文章词汇丰富度要继续努力', '作者词汇多样性不足', '文中词汇丰富度要提高', '作者能较灵活地使用词汇表达', '文中词汇多样性不足', '词汇量还要继续积累', '词汇丰富度总体不足', '文章词汇使用要更加灵活', '作者词汇表达较恰当', '词汇多样性还不够', '文章词汇使用要多样些', '文中词汇表达较准确', '作者用词较为灵活', '文章词汇多样性要提升', '请加强词汇表达的多样性', '文中词汇表达较熟练丰富度不够', '作者能较熟练地使用丰富的词汇', '词汇表达较灵活准确', '文章词汇表达比较灵活', '文中词汇表达较灵活', '作者能较灵活的使用词汇', '文章词汇表达多样性尚可', '文中词汇表达较为丰富准确', '作者能较准确地使用丰富的词汇', '文章词汇表达比较丰富', '文中词汇表达较丰富恰当', '作者词汇表达较为熟练', '词汇表达丰富度要注意', '请作者加强词汇表达的灵活性', '作者词汇表达较准确熟练', '文章用了较为丰富的词汇', '文中词汇表达较灵活丰富', '文中词汇较灵活', '作者能较熟练、灵活地使用词汇', '文中词汇表达比较多样', '作者词汇使用较为丰富熟练', '作者能较灵活地使用词汇', '作者词汇表达比较多样', '作者词汇表达较丰富准确', '作者平时练习中应扩充词汇量', '作者能较灵活准确地使用词汇表达', '在平时练习中注意词汇量的积累', '作者词汇量比较丰富', '文中词汇表达比较丰富', '文章词汇使用丰富度还要提高', '作者能较熟练地使用词汇表达', '词汇量尚可', '作者能较多样地使用词汇', '文中词汇表达用的较灵活', '词汇量积累还要努力', '作者能较灵活准确地使用词汇', '词汇表达较为丰富', '总体词汇丰富度要加强', '高级词汇表达灵活', '词汇表达较丰富', '作者词汇表达较灵活', '作者能较熟练的使用不同词汇', '文章词汇表达较丰富', '文中词汇表达较为丰富', '文中词汇使用较丰富', '作者词汇量积累很好', '文章丰富的词汇表达请发扬', '文中词汇表达较为多样', '作者能较多样的使用词汇表达', '文章能较灵活使用词汇', '作者词汇表达丰富度较高', '作者用词表达较丰富', '请作者词汇表达更加灵活多变一些', '作者能较熟练地使用多样的词汇表达', '词汇表达用的较丰富', '文中词汇表达较为灵活', '作者词汇表达较丰富', '文章词汇使用比较恰当', '文中词汇表达使用较丰富', '作者能较熟练地使用较丰富词汇', '文中词汇表达方面较丰富灵活', '文章词汇使用较为恰当灵活', '作者词汇基础挺好', '文章词汇丰富度较好', '文中能使用多样的词汇表达', '作者词汇量积累较好', '作者词汇量积累需要继续努力', '作者能较恰当使用丰富词汇', '文章词汇表达灵活恰当', '文中词汇使用较丰富恰当', '文章使用了较丰富的词汇表达', '作者词汇表达较丰富多样', '平时练习中注意词汇量的积累', '词汇量需积累', '作者词汇表达比较灵活多变', '作者词汇表达较多样灵活', '文章词汇表达丰富', '文中词汇使用灵活', '文中词汇表达灵活多样', '作者词汇基础不错', '作者用词生动多样', '用词丰富', '作者词汇表达恰当灵活', '作者词汇基础扎实', '作者词汇表达恰当', '作者词汇表达灵活多样请继续发扬', '词汇运用灵活', '作者词汇量积累不错', '文中用词灵活多样', '作者词汇积累不错', '文章用词灵活多样', '高级词汇量还要多多积累', '作者词汇基本功很好', '词汇表达灵活多样请继续保持', '文中词汇表达多样请继续保持', '词汇表达灵活多样', '作者用词灵活多样', '用词灵活多样', '词汇表达灵活丰富请继续保持', '文章词汇表达多样请继续保持', '作者词汇表达灵活多样请继续保持', '文中词汇表达灵活多样请继续保持', '文中词汇表达灵活多变', '作者词汇基本功不错', '作者词汇表达灵活丰富', '作者词汇基础很好', '作者词汇使用熟练灵活', '作者词汇表达丰富灵活', '作者词汇基本功很棒', '文中词汇的表达很灵活', '词汇表达丰富、灵活', '词汇基本功不错', '作者词汇表达丰富多彩', '文章词汇表达做的很好']],
'spell_correct_ratio':[[0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 1.9, 2.0, 2.1, 2.2, 2.3, 2.4, 2.5, 2.6, 2.7, 2.8, 2.9, 3.0, 3.1, 3.2, 3.3, 3.4, 3.5, 3.6, 3.79, 3.8, 3.81, 3.82, 3.83, 3.84, 3.85, 3.86, 3.87, 3.88, 3.89, 3.9, 3.91, 3.92, 3.93, 3.94, 3.942, 3.945, 3.95, 3.955, 3.96, 3.965, 3.97, 3.975, 3.98, 3.985, 3.99, 3.995, 4.0, 4.015, 4.03, 4.045, 4.06, 4.075, 4.09, 4.105, 4.12, 4.135, 4.15, 4.165, 4.18, 4.195, 4.21, 4.225, 4.24, 4.255, 4.27, 4.285, 4.29, 4.305, 4.325, 4.35, 4.355, 4.36, 4.365, 4.37, 4.375, 4.38, 4.385, 4.39, 4.395, 4.4, 4.405, 4.41, 4.415, 4.42, 4.425, 4.43, 4.435, 4.44, 4.445, 4.45, 4.455, 4.46, 4.465, 4.47, 4.475, 4.48, 4.485, 4.49, 4.495, 4.5, 4.5, 4.505, 4.51, 4.515, 4.52, 4.52, 4.525, 4.53, 4.535, 4.54, 4.545, 4.547, 4.55, 4.56, 4.59, 4.62, 4.65, 4.68, 4.71, 4.74, 4.77, 4.8, 4.83, 4.86, 4.89, 4.92, 4.95, 4.98, 5.01, 5.04, 5.07, 5.13, 5.16, 5.19, 5.22, 5.25, 5.28, 5.31, 5.37, 5.43, 5.47, 5.5, 5.53, 5.54, 5.55, 5.56, 5.57, 5.58, 5.59, 5.61, 5.62, 5.63, 5.64, 5.65, 5.66, 5.67, 5.68, 5.69, 5.7, 5.71, 5.72, 5.73, 5.74, 5.75, 5.76, 5.77, 5.78, 5.79, 5.8, 5.81, 5.82, 5.83, 5.84, 5.85, 5.86, 5.87, 5.88, 5.89, 5.9, 5.91, 5.92, 5.925, 5.93, 5.94, 5.945, 5.95, 5.96, 5.97, 5.98, 5.99, 5.995, 6.0, 6.05, 6.1, 6.15, 6.2, 6.25, 6.3, 6.35, 6.4, 6.45, 6.47, 6.5, 6.53, 6.56, 6.59, 6.62, 6.65, 6.68, 6.71, 6.74, 6.77, 6.8, 6.83, 6.86, 6.92, 6.95, 6.98, 7.13, 7.2, 7.25, 7.3, 7.35, 7.4, 7.45, 7.5, 7.55, 7.6, 7.65, 7.7], ['词汇表达贫乏', '用词太过单一', '用词稍显贫乏', '文章用词太过单一', '请作者增加词汇量的积累', '文章词汇表达不够丰富', '文中用词稍显贫乏', '请作者增加词汇丰富度', '请注意积累词汇量', '请注意词汇表达的多样性', '请增加词汇量的积累', '请作者注意积累词汇量', '请作者增加词汇表达的丰富度', '文中词汇表达稍欠丰富', '文中词汇表达贫乏', '请注意词汇量的积累', '作者词汇量偏小', '作者词汇量偏少', '请注意增加词汇的积累', '作者词汇基础较薄弱', '文中词汇表达不够丰富', '文中词汇表达过于贫乏', '请作者增加词汇表达的丰富度，注意积累词汇量', '增加词汇表达丰富度', '作者词汇量不足', '文中词汇表达太过贫乏', '请注意积累词汇量，文中词汇表达贫乏', '总体用词稍显贫乏', '词汇表达总体不够丰富', '词汇量偏少', '请作者增加词汇表达', '词汇表达不够灵活', '词汇量总体上不足', '请增加词汇的积累', '整体词汇不够丰富', '总体词汇量偏小', '需增加词汇量', '作者词汇表达不够丰富', '作者词汇量偏小，文章用词太过单一', '请注意词汇量的增加', '请注意积累词汇', '文中词汇表达不灵活', '注意积累词汇量', '文章用词过于单一', '请使用丰富多样的词汇表达', '文中词汇表达多样性不足', '请使用灵活多样的词汇表达', '文中词汇稍显贫乏', '作者词汇量提升空间很大', '总体词汇表达不够丰富', '总体表达较呆板', '词汇不够丰富', '总体用词较为单一', '需增加词汇丰富度', '要注意积累词汇量', '总体词汇量较小', '词汇总体比较贫乏', '词汇量积累不足', '需注意增加词汇丰富度', '需注意积累词汇量', '表达不灵活', '总体词汇表达不够灵活', '用词稍显单一', '文中词汇表达总体贫乏', '需请作者增加词汇丰富度', '作者词汇量有些小', '再增加词汇量积累就更好了', '作者词汇量较小', '文章用词有些单一', '请作者增加词汇表达的灵活性', '文章词汇表达稍显呆板', '作者词汇表达不够灵活', '文中词汇表达稍显单一', '词汇表达不够丰富', '总体词汇表达贫乏', '需增加词汇表达灵活性', '词汇量积累需要继续加大努力', '请作者注意增加词汇表达的丰富度', '词汇量总体较小', '词汇表达稍显贫乏', '若能增加词汇丰富度就更好了', '日常练习中要注意积累词汇量', '希望能改善用词单一的情况', '词汇量总体偏小', '词汇量的积累还要努力', '文中词汇表达稍显贫乏', '需作者增加词汇丰富度', '总体词汇量稍小', '文中词汇表达多样性要加强', '文中词汇表达丰富度要加强', '作者词汇表达丰富度不足', '文章词汇不够丰富', '文中词汇丰富度不足', '希望作者能加强词汇表达多样性', '请作者注意词汇表达多样性', '作者词汇积累很好', '文章词汇表达多样性要提高', '文中缺乏丰富的词汇表达', '文章词汇表达多样性不够', '作者词汇表达不够多样', '文章词汇表达丰富度要提高', '文中词汇表达丰富度要提升', '作者词汇表达的灵活性要加强', '文中词汇多样性稍有欠缺', '作者词汇表达灵活性稍有欠缺', '作者使用词汇表达不够灵活', '作者词汇表达丰富度要继续提升', '请作者提高词汇表达丰富度', '词汇表达丰富度不足', '文中词汇表达丰富度不足', '文章词汇表达要更加熟练', '平时练习过程中应注意词汇量的积累', '词汇稍欠丰富', '文章词汇使用多样性不足', '文中词汇丰富度还有很大的提升空间', '请作者在词汇丰富度提升上多下功夫', '文中词汇表达灵活性要提高', '词汇积累还有很大进步空间', '请作者加强词汇表达的多样性', '文章词汇丰富度要继续努力', '作者词汇多样性不足', '文中词汇丰富度要提高', '作者能较灵活地使用词汇表达', '文中词汇多样性不足', '词汇量还要继续积累', '词汇丰富度总体不足', '文章词汇使用要更加灵活', '作者词汇表达较恰当', '词汇多样性还不够', '文章词汇使用要多样些', '文中词汇表达较准确', '作者用词较为灵活', '文章词汇多样性要提升', '请加强词汇表达的多样性', '文中词汇表达较熟练丰富度不够', '作者能较熟练地使用丰富的词汇', '词汇表达较灵活准确', '文章词汇表达比较灵活', '文中词汇表达较灵活', '作者能较灵活的使用词汇', '文章词汇表达多样性尚可', '文中词汇表达较为丰富准确', '作者能较准确地使用丰富的词汇', '文章词汇表达比较丰富', '文中词汇表达较丰富恰当', '作者词汇表达较为熟练', '词汇表达丰富度要注意', '请作者加强词汇表达的灵活性', '作者词汇表达较准确熟练', '文章用了较为丰富的词汇', '文中词汇表达较灵活丰富', '文中词汇较灵活', '作者能较熟练、灵活地使用词汇', '文中词汇表达比较多样', '作者词汇使用较为丰富熟练', '作者能较灵活地使用词汇', '作者词汇表达比较多样', '作者词汇表达较丰富准确', '作者平时练习中应扩充词汇量', '作者能较灵活准确地使用词汇表达', '在平时练习中注意词汇量的积累', '作者词汇量比较丰富', '文中词汇表达比较丰富', '文章词汇使用丰富度还要提高', '作者能较熟练地使用词汇表达', '词汇量尚可', '作者能较多样地使用词汇', '文中词汇表达用的较灵活', '词汇量积累还要努力', '作者能较灵活准确地使用词汇', '词汇表达较为丰富', '总体词汇丰富度要加强', '高级词汇表达灵活', '词汇表达较丰富', '作者词汇表达较灵活', '作者能较熟练的使用不同词汇', '文章词汇表达较丰富', '文中词汇表达较为丰富', '文中词汇使用较丰富', '作者词汇量积累很好', '文章丰富的词汇表达请发扬', '文中词汇表达较为多样', '作者能较多样的使用词汇表达', '文章能较灵活使用词汇', '作者词汇表达丰富度较高', '作者用词表达较丰富', '请作者词汇表达更加灵活多变一些', '作者能较熟练地使用多样的词汇表达', '词汇表达用的较丰富', '文中词汇表达较为灵活', '作者词汇表达较丰富', '文章词汇使用比较恰当', '文中词汇表达使用较丰富', '作者能较熟练地使用较丰富词汇', '文中词汇表达方面较丰富灵活', '文章词汇使用较为恰当灵活', '作者词汇基础挺好', '文章词汇丰富度较好', '文中能使用多样的词汇表达', '作者词汇量积累较好', '作者词汇量积累需要继续努力', '作者能较恰当使用丰富词汇', '文章词汇表达灵活恰当', '文中词汇使用较丰富恰当', '文章使用了较丰富的词汇表达', '作者词汇表达较丰富多样', '平时练习中注意词汇量的积累', '词汇量需积累', '作者词汇表达比较灵活多变', '作者词汇表达较多样灵活', '文章词汇表达丰富', '文中词汇使用灵活', '文中词汇表达灵活多样', '作者词汇基础不错', '作者用词生动多样', '用词丰富', '作者词汇表达恰当灵活', '作者词汇基础扎实', '作者词汇表达恰当', '作者词汇表达灵活多样请继续发扬', '词汇运用灵活', '作者词汇量积累不错', '文中用词灵活多样', '作者词汇积累不错', '文章用词灵活多样', '高级词汇量还要多多积累', '作者词汇基本功很好', '词汇表达灵活多样请继续保持', '文中词汇表达多样请继续保持', '词汇表达灵活多样', '作者用词灵活多样', '用词灵活多样', '词汇表达灵活丰富请继续保持', '文章词汇表达多样请继续保持', '作者词汇表达灵活多样请继续保持', '文中词汇表达灵活多样请继续保持', '文中词汇表达灵活多变', '作者词汇基本功不错', '作者词汇表达灵活丰富', '作者词汇基础很好', '作者词汇使用熟练灵活', '作者词汇表达丰富灵活', '作者词汇基本功很棒', '文中词汇的表达很灵活', '词汇表达丰富、灵活', '词汇基本功不错', '作者词汇表达丰富多彩', '文章词汇表达做的很好']],
'ttr1':[[0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 1.9, 2.0, 2.1, 2.2, 2.3, 2.4, 2.5, 2.6, 2.7, 2.8, 2.9, 3.0, 3.1, 3.2, 3.3, 3.4, 3.5, 3.6, 3.79, 3.8, 3.81, 3.82, 3.83, 3.84, 3.85, 3.86, 3.87, 3.88, 3.89, 3.9, 3.91, 3.92, 3.93, 3.94, 3.942, 3.945, 3.95, 3.955, 3.96, 3.965, 3.97, 3.975, 3.98, 3.985, 3.99, 3.995, 4.0, 4.015, 4.03, 4.045, 4.06, 4.075, 4.09, 4.105, 4.12, 4.135, 4.15, 4.165, 4.18, 4.195, 4.21, 4.225, 4.24, 4.255, 4.27, 4.285, 4.29, 4.305, 4.325, 4.35, 4.355, 4.36, 4.365, 4.37, 4.375, 4.38, 4.385, 4.39, 4.395, 4.4, 4.405, 4.41, 4.415, 4.42, 4.425, 4.43, 4.435, 4.44, 4.445, 4.45, 4.455, 4.46, 4.465, 4.47, 4.475, 4.48, 4.485, 4.49, 4.495, 4.5, 4.5, 4.505, 4.51, 4.515, 4.52, 4.52, 4.525, 4.53, 4.535, 4.54, 4.545, 4.547, 4.55, 4.56, 4.59, 4.62, 4.65, 4.68, 4.71, 4.74, 4.77, 4.8, 4.83, 4.86, 4.89, 4.92, 4.95, 4.98, 5.01, 5.04, 5.07, 5.13, 5.16, 5.19, 5.22, 5.25, 5.28, 5.31, 5.37, 5.43, 5.47, 5.5, 5.53, 5.54, 5.55, 5.56, 5.57, 5.58, 5.59, 5.61, 5.62, 5.63, 5.64, 5.65, 5.66, 5.67, 5.68, 5.69, 5.7, 5.71, 5.72, 5.73, 5.74, 5.75, 5.76, 5.77, 5.78, 5.79, 5.8, 5.81, 5.82, 5.83, 5.84, 5.85, 5.86, 5.87, 5.88, 5.89, 5.9, 5.91, 5.92, 5.925, 5.93, 5.94, 5.945, 5.95, 5.96, 5.97, 5.98, 5.99, 5.995, 6.0, 6.05, 6.1, 6.15, 6.2, 6.25, 6.3, 6.35, 6.4, 6.45, 6.47, 6.5, 6.53, 6.56, 6.59, 6.62, 6.65, 6.68, 6.71, 6.74, 6.77, 6.8, 6.83, 6.86, 6.92, 6.95, 6.98, 7.13, 7.2, 7.25, 7.3, 7.35, 7.4, 7.45, 7.5, 7.55, 7.6, 7.65, 7.7], ['词汇表达贫乏', '用词太过单一', '用词稍显贫乏', '文章用词太过单一', '请作者增加词汇量的积累', '文章词汇表达不够丰富', '文中用词稍显贫乏', '请作者增加词汇丰富度', '请注意积累词汇量', '请注意词汇表达的多样性', '请增加词汇量的积累', '请作者注意积累词汇量', '请作者增加词汇表达的丰富度', '文中词汇表达稍欠丰富', '文中词汇表达贫乏', '请注意词汇量的积累', '作者词汇量偏小', '作者词汇量偏少', '请注意增加词汇的积累', '作者词汇基础较薄弱', '文中词汇表达不够丰富', '文中词汇表达过于贫乏', '请作者增加词汇表达的丰富度，注意积累词汇量', '增加词汇表达丰富度', '作者词汇量不足', '文中词汇表达太过贫乏', '请注意积累词汇量，文中词汇表达贫乏', '总体用词稍显贫乏', '词汇表达总体不够丰富', '词汇量偏少', '请作者增加词汇表达', '词汇表达不够灵活', '词汇量总体上不足', '请增加词汇的积累', '整体词汇不够丰富', '总体词汇量偏小', '需增加词汇量', '作者词汇表达不够丰富', '作者词汇量偏小，文章用词太过单一', '请注意词汇量的增加', '请注意积累词汇', '文中词汇表达不灵活', '注意积累词汇量', '文章用词过于单一', '请使用丰富多样的词汇表达', '文中词汇表达多样性不足', '请使用灵活多样的词汇表达', '文中词汇稍显贫乏', '作者词汇量提升空间很大', '总体词汇表达不够丰富', '总体表达较呆板', '词汇不够丰富', '总体用词较为单一', '需增加词汇丰富度', '要注意积累词汇量', '总体词汇量较小', '词汇总体比较贫乏', '词汇量积累不足', '需注意增加词汇丰富度', '需注意积累词汇量', '表达不灵活', '总体词汇表达不够灵活', '用词稍显单一', '文中词汇表达总体贫乏', '需请作者增加词汇丰富度', '作者词汇量有些小', '再增加词汇量积累就更好了', '作者词汇量较小', '文章用词有些单一', '请作者增加词汇表达的灵活性', '文章词汇表达稍显呆板', '作者词汇表达不够灵活', '文中词汇表达稍显单一', '词汇表达不够丰富', '总体词汇表达贫乏', '需增加词汇表达灵活性', '词汇量积累需要继续加大努力', '请作者注意增加词汇表达的丰富度', '词汇量总体较小', '词汇表达稍显贫乏', '若能增加词汇丰富度就更好了', '日常练习中要注意积累词汇量', '希望能改善用词单一的情况', '词汇量总体偏小', '词汇量的积累还要努力', '文中词汇表达稍显贫乏', '需作者增加词汇丰富度', '总体词汇量稍小', '文中词汇表达多样性要加强', '文中词汇表达丰富度要加强', '作者词汇表达丰富度不足', '文章词汇不够丰富', '文中词汇丰富度不足', '希望作者能加强词汇表达多样性', '请作者注意词汇表达多样性', '作者词汇积累很好', '文章词汇表达多样性要提高', '文中缺乏丰富的词汇表达', '文章词汇表达多样性不够', '作者词汇表达不够多样', '文章词汇表达丰富度要提高', '文中词汇表达丰富度要提升', '作者词汇表达的灵活性要加强', '文中词汇多样性稍有欠缺', '作者词汇表达灵活性稍有欠缺', '作者使用词汇表达不够灵活', '作者词汇表达丰富度要继续提升', '请作者提高词汇表达丰富度', '词汇表达丰富度不足', '文中词汇表达丰富度不足', '文章词汇表达要更加熟练', '平时练习过程中应注意词汇量的积累', '词汇稍欠丰富', '文章词汇使用多样性不足', '文中词汇丰富度还有很大的提升空间', '请作者在词汇丰富度提升上多下功夫', '文中词汇表达灵活性要提高', '词汇积累还有很大进步空间', '请作者加强词汇表达的多样性', '文章词汇丰富度要继续努力', '作者词汇多样性不足', '文中词汇丰富度要提高', '作者能较灵活地使用词汇表达', '文中词汇多样性不足', '词汇量还要继续积累', '词汇丰富度总体不足', '文章词汇使用要更加灵活', '作者词汇表达较恰当', '词汇多样性还不够', '文章词汇使用要多样些', '文中词汇表达较准确', '作者用词较为灵活', '文章词汇多样性要提升', '请加强词汇表达的多样性', '文中词汇表达较熟练丰富度不够', '作者能较熟练地使用丰富的词汇', '词汇表达较灵活准确', '文章词汇表达比较灵活', '文中词汇表达较灵活', '作者能较灵活的使用词汇', '文章词汇表达多样性尚可', '文中词汇表达较为丰富准确', '作者能较准确地使用丰富的词汇', '文章词汇表达比较丰富', '文中词汇表达较丰富恰当', '作者词汇表达较为熟练', '词汇表达丰富度要注意', '请作者加强词汇表达的灵活性', '作者词汇表达较准确熟练', '文章用了较为丰富的词汇', '文中词汇表达较灵活丰富', '文中词汇较灵活', '作者能较熟练、灵活地使用词汇', '文中词汇表达比较多样', '作者词汇使用较为丰富熟练', '作者能较灵活地使用词汇', '作者词汇表达比较多样', '作者词汇表达较丰富准确', '作者平时练习中应扩充词汇量', '作者能较灵活准确地使用词汇表达', '在平时练习中注意词汇量的积累', '作者词汇量比较丰富', '文中词汇表达比较丰富', '文章词汇使用丰富度还要提高', '作者能较熟练地使用词汇表达', '词汇量尚可', '作者能较多样地使用词汇', '文中词汇表达用的较灵活', '词汇量积累还要努力', '作者能较灵活准确地使用词汇', '词汇表达较为丰富', '总体词汇丰富度要加强', '高级词汇表达灵活', '词汇表达较丰富', '作者词汇表达较灵活', '作者能较熟练的使用不同词汇', '文章词汇表达较丰富', '文中词汇表达较为丰富', '文中词汇使用较丰富', '作者词汇量积累很好', '文章丰富的词汇表达请发扬', '文中词汇表达较为多样', '作者能较多样的使用词汇表达', '文章能较灵活使用词汇', '作者词汇表达丰富度较高', '作者用词表达较丰富', '请作者词汇表达更加灵活多变一些', '作者能较熟练地使用多样的词汇表达', '词汇表达用的较丰富', '文中词汇表达较为灵活', '作者词汇表达较丰富', '文章词汇使用比较恰当', '文中词汇表达使用较丰富', '作者能较熟练地使用较丰富词汇', '文中词汇表达方面较丰富灵活', '文章词汇使用较为恰当灵活', '作者词汇基础挺好', '文章词汇丰富度较好', '文中能使用多样的词汇表达', '作者词汇量积累较好', '作者词汇量积累需要继续努力', '作者能较恰当使用丰富词汇', '文章词汇表达灵活恰当', '文中词汇使用较丰富恰当', '文章使用了较丰富的词汇表达', '作者词汇表达较丰富多样', '平时练习中注意词汇量的积累', '词汇量需积累', '作者词汇表达比较灵活多变', '作者词汇表达较多样灵活', '文章词汇表达丰富', '文中词汇使用灵活', '文中词汇表达灵活多样', '作者词汇基础不错', '作者用词生动多样', '用词丰富', '作者词汇表达恰当灵活', '作者词汇基础扎实', '作者词汇表达恰当', '作者词汇表达灵活多样请继续发扬', '词汇运用灵活', '作者词汇量积累不错', '文中用词灵活多样', '作者词汇积累不错', '文章用词灵活多样', '高级词汇量还要多多积累', '作者词汇基本功很好', '词汇表达灵活多样请继续保持', '文中词汇表达多样请继续保持', '词汇表达灵活多样', '作者用词灵活多样', '用词灵活多样', '词汇表达灵活丰富请继续保持', '文章词汇表达多样请继续保持', '作者词汇表达灵活多样请继续保持', '文中词汇表达灵活多样请继续保持', '文中词汇表达灵活多变', '作者词汇基本功不错', '作者词汇表达灵活丰富', '作者词汇基础很好', '作者词汇使用熟练灵活', '作者词汇表达丰富灵活', '作者词汇基本功很棒', '文中词汇的表达很灵活', '词汇表达丰富、灵活', '词汇基本功不错', '作者词汇表达丰富多彩', '文章词汇表达做的很好']],
}
pingyus = {'default': pingyu_default}
pingyu_index = {'default': ["spell_correct_ratio,ttr1,b3","ast,snt_correct_ratio,cl_dens","pv_dens,disconj_dens"],	} 

def pingyu_item(dim_value, pair):
	if not dim_value: return 
	try : 
		return pair[1][ max( bisect.bisect(pair[0], dim_value ) -1 , 0) ]
	except Exception as ex:
		print("ex:", ex, "\t|", dim_value, pair) 

pingyu_dims		= lambda dim, name='default', dim_names='ttr1,b3',sepa='，': sepa.join([py for py in [ pingyu_item(dim[dim_name], pingyus.get(name,'default')[dim_name] )  for dim_name in dim_names.split(",") if dim_name in dim] if py])
get_pingyu		= lambda dim, lang='zh', name='default',sepa='；': sepa.join([  pingyu_dims(dim, name, names) for names in pingyu_index.get(name, 'default') ])
def dims_pingyu(dims:dict, name:str='default', lang:str='zh', sepa:str="；", label:str="pingyu"): 	
	''' {"snt_num": 1, "word_gt7": 0.0, "b3": 0.0, "b3_b1": 1.0, "ttr": 99.00990099009901, "ttr1": 0.7071067811865475, "ttr2": 0.9900990099009901, "doc_tc": 1, "cl_sum": 0, "cl_dens": 0.0, "cl_ratio": 0.0, "awl": 6.0, "ast": 1.0, "asl": 6.0, "ast_sd": 0, "mwe_pv": 0.0, "mwe_disconj": 0.0, "pv_dens": 0.0, "disconj_dens": 0.0, "v_ratio": 0.0, "n_ratio": 0.9900990099009901, "jj_ratio": 0.0, "rb_ratio": 0.0, "cc_ratio": 0.0, "comma_ratio": 0.0, "art_ratio": 0.0, "spell_correct_ratio": 1.0, "grammar_err": 0, "grammar_correct_ri": 1.0, "kp_correct_ratio": 1.0, "kp_correct_ri": 0.5, "simple_sent_ratio": 1.0, "simple_sent_ri": 0.5, "snt_correct_ratio": 1.0, "fitted_ratio": 0.0, "internal_sim": 1, "word_diff_avg": 7.1884999999999994, "pred_diff_max3": 0, "prmods_tc": 3.0, "prmods_ratio": 0.15} '''
	return sepa.join([  pingyu_dims(dims, name, names) for names in pingyu_index.get(name, 'default') ])

# needed by wps 
now			= lambda: time.strftime('%Y.%m.%d %H:%M:%S',time.localtime(time.time()))
trantab		= str.maketrans("，　。！“”‘’；：？％＄＠＆＊（）［］＋－ＡＢＣＤＥＦＧＨＩＪＫＬＭＮＯＰＱＲＳＴＵＶＷＸＹＺ１２３４５６７８９０ａｂｃｄｅｆｇｈｉｊｋｌｍｎｏｐｑｒｓｔｕｖｗｘｙｚ", ", .!\"\"'';:?%$@&*()[]+-ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890abcdefghijklmnopqrstuvwxyz") #str.translate(trantab)
valid_ratio	= lambda snt: len(re.sub(r'[\u4e00-\u9fa5]', '', snt.translate(trantab) ) ) / ( len(snt) + 0.01)  #<= ratio  # at least 70% is English

def five_score(v, five_v, five_scores=[0.0,60.0,80.0,90.0,100.0], f = lambda v, v1,v2,s1,s2: s1 + (s2-s1) * (v-v1)/(v2-v1)): 
	if v < five_v[0] : return five_scores[0]
	elif v >= five_v[0] and v < five_v[1] : return f(v, five_v[0], five_v[1], five_scores[0], five_scores[1])
	elif v >= five_v[1] and v < five_v[2] : return f(v, five_v[1], five_v[2], five_scores[1], five_scores[2])
	elif v >= five_v[2] and v < five_v[3] : return f(v, five_v[2], five_v[3], five_scores[2], five_scores[3])
	elif v >= five_v[3] and v < five_v[4] : return f(v, five_v[3], five_v[4], five_scores[3], five_scores[4])
	elif v >= five_v[4] : return five_scores[4]

def dims_score(dims:dict={"doc_tc": 191.0, "asl": 74.6154, "ttr2": 62.2009, "ttr": 57.0651, "ast": 14.6923, "snt_num": 13.0, "cl_sum": 8.0, "pred_diff_max3": 5.9, "ttr1": 5.5769, "word_diff_avg": 4.7957, "awl": 4.2723, "prmods_tc": 4.2308, "e_snt.fitted": 3.0, "ast_sd": 1.3431, "mwe_pv": 1.0769, "spell_correct_ratio": 1.0, "kp_correct_ratio": 0.8849, "internal_sim": 0.8794574205761223, "mwe_disconj": 0.8462, "simple_sent_ri": 0.7647, "cl_ratio": 0.6162, "snt_correct_ratio": 0.3077, "simple_sent_ratio": 0.3077, "grammar_correct_ri": 0.3077, "prmods_ratio": 0.2763, "word_gt7": 0.2669, "n_ratio": 0.2407, "v_ratio": 0.1884, "jj_ratio": 0.1099, "art_ratio": 0.0523, "comma_ratio": 0.0471, "b3_b1": 0.0411, "rb_ratio": 0.0366, "b3": 0.0262, "cc_ratio": 0.0157, "kp_correct_ri": 0.0}, 
	formula:dict= {   # five-range-value, cate, coef, cate-coef
			"ast":[9.9, 11.99, 15.3, 18.51, 25.32,				2,0.0882, 0.3241],
			"awl":[3.5, 4.1, 4.56, 5.1, 6.0,					3,0.0882, 0.5],
			"b3":[0, 0.03, 0.08, 0.12, 0.15 ,					1, 0.0956, 0.2096],
			"cl_sum":[1, 6.68, 12, 16, 26,						2,0.0441, 0.1621],
			"grammar_correct_ri":[0.6, 0.85, 0.92, 0.97,1.0,	2,0.0368, 0.1352],
			"internal_sim":[0.0, 0.08, 0.2, 0.3, 0.4,			4, 0.0735, 0.7688],
			"kp_correct_ri":[0.7, 0.9, 0.95, 0.97, 1,			1, 0.0368, 0.0807],
			"mwe_pv":[0.01,8.03, 12, 20.21, 25,					4, 0.0221, 0.2312],
			"pred_diff_max3":[3.84, 5.11, 6.51, 7.9, 10.09 ,	1, 0.0368, 0.0807],
			"prmods_ratio":[0.06, 0.21, 0.3, 0.4, 0.5,			2, 0.0294, 0.108],
			"prmods_tc":[1.1, 2.76, 4.75, 6.76, 10.0,			2, 0.0368, 0.1352],
			"simple_sent_ri":[0.4, 0.65, 0.9, 0.95, 1,			2, 0.0368, 0.1352],
			"snt_correct_ratio":[0.01, 0.2, 0.45, 0.75, 1,		1, 0.0368, 0.0807],
			"spell_correct_ratio":[0.8, 0.9, 0.97, 0.99, 1,		1, 0.1471, 0.3226],
			"ttr1":[3.43, 4.28, 5.2, 6, 6.8,					3, 0.0882, 0.5],
			"word_diff_avg":[4.47, 4.73, 5.25,5.8, 6.6,			1, 0.0441, 0.0967],
			"word_gt7":[0.11, 0.19, 0.3, 0.42, 0.49,			1, 0.0588, 0.1289]}, 
	qiwang:list=[0.0,60.0,80.0,90.0,100.0], with_dim_score:bool=False):
	''' five-range-value, cate, coef, cate-coef '''
	from collections import Counter 
	dim_scores = {}
	for name, vf in formula.items():
		if name in dims:
			dim_scores[name] = { 'score': five_score( dims[name], vf, qiwang), 'value': dims[name], 'range':vf[0:5], 'cate': vf[5] , 'coef': vf[6], 'cate-coef': vf[7]}
	score = sum([ v['score'] * v['coef'] for name, v in dim_scores.items() if v['score']])
	ratio = sum([ v['coef'] for name, v in dim_scores.items()])
	
	si = Counter()
	[ si.update( {ar['cate'] : round(ar['score'] * ar['cate-coef'], 2)})  for ar in dim_scores.values() if ar['score'] ] #'cate_score_default'
	return {"final_score": round(score/ratio, 2), 'cate_score_default': si, 'dim_score':dim_scores if with_dim_score else {} }

if __name__ == "__main__":  #python gec-dsk.py uvirun 7001
	res = gecdsk()
	print ( res['doc']['grammar_correct_ri'], res['doc']['internal_sim']) 